﻿using System;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.Core.Transforms;

#if NET_CF20
[assembly: ServiceDeclaration(DssServiceDeclaration.Transform, SourceAssemblyKey = @"cf.robocupgui.y2008.m01, version=0.0.0.0, culture=neutral, publickeytoken=6ed2948c787ef221")]
#else
[assembly: ServiceDeclaration(DssServiceDeclaration.Transform, SourceAssemblyKey = @"robocupgui.y2008.m01, version=0.0.0.0, culture=neutral, publickeytoken=6ed2948c787ef221")]
#endif
#if !URT_MINCLR
[assembly: System.Security.SecurityTransparent]
[assembly: System.Security.AllowPartiallyTrustedCallers]
#endif

namespace Dss.Transforms.TransformRoboCupGUI
{

    public class Transforms: TransformBase
    {

        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_RoboCupGUIState_TO_Microsoft_Robotics_Services_RoboCupGUI_RoboCupGUIState(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.RoboCupGUIState target = new Microsoft.Robotics.Services.RoboCupGUI.RoboCupGUIState();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.RoboCupGUIState from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.RoboCupGUIState;
            target.TimeStamp = from.TimeStamp;
            target.xPos = from.xPos;
            target.yPos = from.yPos;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_RoboCupGUIState_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_RoboCupGUIState(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.RoboCupGUIState target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.RoboCupGUIState();
            Microsoft.Robotics.Services.RoboCupGUI.RoboCupGUIState from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.RoboCupGUIState;
            target.TimeStamp = from.TimeStamp;
            target.xPos = from.xPos;
            target.yPos = from.yPos;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ConnectCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_ConnectCMDRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.ConnectCMDRequest target = new Microsoft.Robotics.Services.RoboCupGUI.ConnectCMDRequest();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.ConnectCMDRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.ConnectCMDRequest;
            target.IP = from.IP;
            target.gameBotPort = from.gameBotPort;
            target.imgSvrPort = from.imgSvrPort;
            target.wssPort = from.wssPort;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_ConnectCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ConnectCMDRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.ConnectCMDRequest target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.ConnectCMDRequest();
            Microsoft.Robotics.Services.RoboCupGUI.ConnectCMDRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.ConnectCMDRequest;
            target.IP = from.IP;
            target.gameBotPort = from.gameBotPort;
            target.imgSvrPort = from.imgSvrPort;
            target.wssPort = from.wssPort;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_DisconnectCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_DisconnectCMDRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.DisconnectCMDRequest target = new Microsoft.Robotics.Services.RoboCupGUI.DisconnectCMDRequest();
            return target;
        }


        private static Microsoft.Robotics.Services.RoboCupGUI.Proxy.DisconnectCMDRequest _instance_Microsoft_Robotics_Services_RoboCupGUI_Proxy_DisconnectCMDRequest = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.DisconnectCMDRequest();
        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_DisconnectCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_DisconnectCMDRequest(object ignore)
        {
            return _instance_Microsoft_Robotics_Services_RoboCupGUI_Proxy_DisconnectCMDRequest;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GetPosesCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_GetPosesCMDRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.GetPosesCMDRequest target = new Microsoft.Robotics.Services.RoboCupGUI.GetPosesCMDRequest();
            return target;
        }


        private static Microsoft.Robotics.Services.RoboCupGUI.Proxy.GetPosesCMDRequest _instance_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GetPosesCMDRequest = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.GetPosesCMDRequest();
        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_GetPosesCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GetPosesCMDRequest(object ignore)
        {
            return _instance_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GetPosesCMDRequest;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_InitCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_InitCMDRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.InitCMDRequest target = new Microsoft.Robotics.Services.RoboCupGUI.InitCMDRequest();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.InitCMDRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.InitCMDRequest;
            target.Robot = from.Robot;
            target.Name = from.Name;
            target.Location = from.Location;
            target.Rotation = from.Rotation;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_InitCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_InitCMDRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.InitCMDRequest target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.InitCMDRequest();
            Microsoft.Robotics.Services.RoboCupGUI.InitCMDRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.InitCMDRequest;
            target.Robot = from.Robot;
            target.Name = from.Name;
            target.Location = from.Location;
            target.Rotation = from.Rotation;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_DriveAerialCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_DriveAerialCMDRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.DriveAerialCMDRequest target = new Microsoft.Robotics.Services.RoboCupGUI.DriveAerialCMDRequest();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.DriveAerialCMDRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.DriveAerialCMDRequest;
            target.AltitudeVelocity = from.AltitudeVelocity;
            target.LinearVelocity = from.LinearVelocity;
            target.LateralVelocity = from.LateralVelocity;
            target.RotationalVelocity = from.RotationalVelocity;
            target.Normalized = from.Normalized;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_DriveAerialCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_DriveAerialCMDRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.DriveAerialCMDRequest target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.DriveAerialCMDRequest();
            Microsoft.Robotics.Services.RoboCupGUI.DriveAerialCMDRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.DriveAerialCMDRequest;
            target.AltitudeVelocity = from.AltitudeVelocity;
            target.LinearVelocity = from.LinearVelocity;
            target.LateralVelocity = from.LateralVelocity;
            target.RotationalVelocity = from.RotationalVelocity;
            target.Normalized = from.Normalized;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_MisPkgCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_MisPkgCMDRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.MisPkgCMDRequest target = new Microsoft.Robotics.Services.RoboCupGUI.MisPkgCMDRequest();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.MisPkgCMDRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.MisPkgCMDRequest;
            target.Name = from.Name;

            // copy IEnumerable Link
            if (from.Link != null)
            {
                target.Link = new System.Collections.Generic.List<Microsoft.Robotics.Services.RoboCupGUI.LinkProperty>();
                foreach(Microsoft.Robotics.Services.RoboCupGUI.Proxy.LinkProperty elem in from.Link)
                {
                    target.Link.Add((elem == null) ? null : (Microsoft.Robotics.Services.RoboCupGUI.LinkProperty)Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_LinkProperty_TO_Microsoft_Robotics_Services_RoboCupGUI_LinkProperty(elem));
                }
            }
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_MisPkgCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_MisPkgCMDRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.MisPkgCMDRequest target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.MisPkgCMDRequest();
            Microsoft.Robotics.Services.RoboCupGUI.MisPkgCMDRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.MisPkgCMDRequest;
            target.Name = from.Name;

            // copy IEnumerable Link
            if (from.Link != null)
            {
                target.Link = new System.Collections.Generic.List<Microsoft.Robotics.Services.RoboCupGUI.Proxy.LinkProperty>();
                foreach(Microsoft.Robotics.Services.RoboCupGUI.LinkProperty elem in from.Link)
                {
                    target.Link.Add((elem == null) ? null : (Microsoft.Robotics.Services.RoboCupGUI.Proxy.LinkProperty)Transform_Microsoft_Robotics_Services_RoboCupGUI_LinkProperty_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_LinkProperty(elem));
                }
            }
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ImgSvrCamCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_ImgSvrCamCMDRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.ImgSvrCamCMDRequest target = new Microsoft.Robotics.Services.RoboCupGUI.ImgSvrCamCMDRequest();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.ImgSvrCamCMDRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.ImgSvrCamCMDRequest;
            target.RobotName = from.RobotName;
            target.CamName = from.CamName;
            target.IP = from.IP;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_ImgSvrCamCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ImgSvrCamCMDRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.ImgSvrCamCMDRequest target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.ImgSvrCamCMDRequest();
            Microsoft.Robotics.Services.RoboCupGUI.ImgSvrCamCMDRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.ImgSvrCamCMDRequest;
            target.RobotName = from.RobotName;
            target.CamName = from.CamName;
            target.IP = from.IP;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ImgSvrOKCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_ImgSvrOKCMDRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.ImgSvrOKCMDRequest target = new Microsoft.Robotics.Services.RoboCupGUI.ImgSvrOKCMDRequest();
            return target;
        }


        private static Microsoft.Robotics.Services.RoboCupGUI.Proxy.ImgSvrOKCMDRequest _instance_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ImgSvrOKCMDRequest = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.ImgSvrOKCMDRequest();
        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_ImgSvrOKCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ImgSvrOKCMDRequest(object ignore)
        {
            return _instance_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ImgSvrOKCMDRequest;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_WaypointCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_WaypointCMDRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.WaypointCMDRequest target = new Microsoft.Robotics.Services.RoboCupGUI.WaypointCMDRequest();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.WaypointCMDRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.WaypointCMDRequest;
            target.GPS = (from.GPS == null) ? null : (Microsoft.Robotics.Services.RoboCupGUI.RoboCupGUIState)Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_RoboCupGUIState_TO_Microsoft_Robotics_Services_RoboCupGUI_RoboCupGUIState(from.GPS);
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_WaypointCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_WaypointCMDRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.WaypointCMDRequest target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.WaypointCMDRequest();
            Microsoft.Robotics.Services.RoboCupGUI.WaypointCMDRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.WaypointCMDRequest;
            target.GPS = (from.GPS == null) ? null : (Microsoft.Robotics.Services.RoboCupGUI.Proxy.RoboCupGUIState)Transform_Microsoft_Robotics_Services_RoboCupGUI_RoboCupGUIState_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_RoboCupGUIState(from.GPS);
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ConnectedMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_ConnectedMSGRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.ConnectedMSGRequest target = new Microsoft.Robotics.Services.RoboCupGUI.ConnectedMSGRequest();
            return target;
        }


        private static Microsoft.Robotics.Services.RoboCupGUI.Proxy.ConnectedMSGRequest _instance_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ConnectedMSGRequest = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.ConnectedMSGRequest();
        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_ConnectedMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ConnectedMSGRequest(object ignore)
        {
            return _instance_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ConnectedMSGRequest;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_StartPosesMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_StartPosesMSGRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.StartPosesMSGRequest target = new Microsoft.Robotics.Services.RoboCupGUI.StartPosesMSGRequest();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.StartPosesMSGRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.StartPosesMSGRequest;

            // copy IEnumerable startPoses
            if (from.startPoses != null)
            {
                target.startPoses = new System.Collections.Generic.List<Microsoft.Robotics.Services.RoboCupGUI.StartPoses>();
                foreach(Microsoft.Robotics.Services.RoboCupGUI.Proxy.StartPoses elem in from.startPoses)
                {
                    target.startPoses.Add((elem == null) ? null : (Microsoft.Robotics.Services.RoboCupGUI.StartPoses)Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_StartPoses_TO_Microsoft_Robotics_Services_RoboCupGUI_StartPoses(elem));
                }
            }
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_StartPosesMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_StartPosesMSGRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.StartPosesMSGRequest target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.StartPosesMSGRequest();
            Microsoft.Robotics.Services.RoboCupGUI.StartPosesMSGRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.StartPosesMSGRequest;

            // copy IEnumerable startPoses
            if (from.startPoses != null)
            {
                target.startPoses = new System.Collections.Generic.List<Microsoft.Robotics.Services.RoboCupGUI.Proxy.StartPoses>();
                foreach(Microsoft.Robotics.Services.RoboCupGUI.StartPoses elem in from.startPoses)
                {
                    target.startPoses.Add((elem == null) ? null : (Microsoft.Robotics.Services.RoboCupGUI.Proxy.StartPoses)Transform_Microsoft_Robotics_Services_RoboCupGUI_StartPoses_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_StartPoses(elem));
                }
            }
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_InitializedMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_InitializedMSGRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.InitializedMSGRequest target = new Microsoft.Robotics.Services.RoboCupGUI.InitializedMSGRequest();
            return target;
        }


        private static Microsoft.Robotics.Services.RoboCupGUI.Proxy.InitializedMSGRequest _instance_Microsoft_Robotics_Services_RoboCupGUI_Proxy_InitializedMSGRequest = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.InitializedMSGRequest();
        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_InitializedMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_InitializedMSGRequest(object ignore)
        {
            return _instance_Microsoft_Robotics_Services_RoboCupGUI_Proxy_InitializedMSGRequest;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_StaMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_StaMSGRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.StaMSGRequest target = new Microsoft.Robotics.Services.RoboCupGUI.StaMSGRequest();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.StaMSGRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.StaMSGRequest;
            target.botStatus = (from.botStatus == null) ? null : (Microsoft.Robotics.Services.RoboCupGUI.BotStatus)Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_BotStatus_TO_Microsoft_Robotics_Services_RoboCupGUI_BotStatus(from.botStatus);
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_StaMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_StaMSGRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.StaMSGRequest target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.StaMSGRequest();
            Microsoft.Robotics.Services.RoboCupGUI.StaMSGRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.StaMSGRequest;
            target.botStatus = (from.botStatus == null) ? null : (Microsoft.Robotics.Services.RoboCupGUI.Proxy.BotStatus)Transform_Microsoft_Robotics_Services_RoboCupGUI_BotStatus_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_BotStatus(from.botStatus);
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GPSMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_GPSMSGRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.GPSMSGRequest target = new Microsoft.Robotics.Services.RoboCupGUI.GPSMSGRequest();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.GPSMSGRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.GPSMSGRequest;
            target.gps = (from.gps == null) ? null : (Microsoft.Robotics.Services.RoboCupGUI.GPS)Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GPS_TO_Microsoft_Robotics_Services_RoboCupGUI_GPS(from.gps);
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_GPSMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GPSMSGRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.GPSMSGRequest target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.GPSMSGRequest();
            Microsoft.Robotics.Services.RoboCupGUI.GPSMSGRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.GPSMSGRequest;
            target.gps = (from.gps == null) ? null : (Microsoft.Robotics.Services.RoboCupGUI.Proxy.GPS)Transform_Microsoft_Robotics_Services_RoboCupGUI_GPS_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GPS(from.gps);
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ImageMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_ImageMSGRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.ImageMSGRequest target = new Microsoft.Robotics.Services.RoboCupGUI.ImageMSGRequest();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.ImageMSGRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.ImageMSGRequest;
            target.JPEG = (from.JPEG == null) ? null : (System.Drawing.Image)((System.ICloneable)from.JPEG).Clone();
            target.Valid = from.Valid;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_ImageMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ImageMSGRequest(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.ImageMSGRequest target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.ImageMSGRequest();
            Microsoft.Robotics.Services.RoboCupGUI.ImageMSGRequest from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.ImageMSGRequest;
            target.JPEG = (from.JPEG == null) ? null : (System.Drawing.Image)((System.ICloneable)from.JPEG).Clone();
            target.Valid = from.Valid;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GPS_TO_Microsoft_Robotics_Services_RoboCupGUI_GPS(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.GPS target = new Microsoft.Robotics.Services.RoboCupGUI.GPS();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.GPS from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.GPS;
            target.TimeStamp = from.TimeStamp;
            target.Name = from.Name;
            target.LatitudeDegrees = from.LatitudeDegrees;
            target.LatitudeMinutes = from.LatitudeMinutes;
            target.LatitudeCardinal = from.LatitudeCardinal;
            target.LongitudeDegrees = from.LongitudeDegrees;
            target.LongitudeMinutes = from.LongitudeMinutes;
            target.LongitudeCardinal = from.LongitudeCardinal;
            target.Fix = from.Fix;
            target.Satellites = from.Satellites;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_GPS_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GPS(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.GPS target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.GPS();
            Microsoft.Robotics.Services.RoboCupGUI.GPS from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.GPS;
            target.TimeStamp = from.TimeStamp;
            target.Name = from.Name;
            target.LatitudeDegrees = from.LatitudeDegrees;
            target.LatitudeMinutes = from.LatitudeMinutes;
            target.LatitudeCardinal = from.LatitudeCardinal;
            target.LongitudeDegrees = from.LongitudeDegrees;
            target.LongitudeMinutes = from.LongitudeMinutes;
            target.LongitudeCardinal = from.LongitudeCardinal;
            target.Fix = from.Fix;
            target.Satellites = from.Satellites;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GroundTruth_TO_Microsoft_Robotics_Services_RoboCupGUI_GroundTruth(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.GroundTruth target = new Microsoft.Robotics.Services.RoboCupGUI.GroundTruth();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.GroundTruth from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.GroundTruth;
            target.TimeStamp = from.TimeStamp;
            target.Name = from.Name;
            target.xPos = from.xPos;
            target.yPos = from.yPos;
            target.zPos = from.zPos;
            target.xRot = from.xRot;
            target.yRot = from.yRot;
            target.zRot = from.zRot;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_GroundTruth_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GroundTruth(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.GroundTruth target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.GroundTruth();
            Microsoft.Robotics.Services.RoboCupGUI.GroundTruth from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.GroundTruth;
            target.TimeStamp = from.TimeStamp;
            target.Name = from.Name;
            target.xPos = from.xPos;
            target.yPos = from.yPos;
            target.zPos = from.zPos;
            target.xRot = from.xRot;
            target.yRot = from.yRot;
            target.zRot = from.zRot;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_LinkProperty_TO_Microsoft_Robotics_Services_RoboCupGUI_LinkProperty(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.LinkProperty target = new Microsoft.Robotics.Services.RoboCupGUI.LinkProperty();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.LinkProperty from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.LinkProperty;
            target.ID = from.ID;
            target.Type = from.Type;
            target.MaxSpeed = from.MaxSpeed;
            target.MaxTorque = from.MaxTorque;
            target.MinRange = from.MinRange;
            target.MaxRange = from.MaxRange;
            target.CurrVal = from.CurrVal;
            target.CurrTorque = from.CurrTorque;
            target.DesiredVal = from.DesiredVal;
            target.DesiredOrder = from.DesiredOrder;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_LinkProperty_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_LinkProperty(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.LinkProperty target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.LinkProperty();
            Microsoft.Robotics.Services.RoboCupGUI.LinkProperty from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.LinkProperty;
            target.ID = from.ID;
            target.Type = from.Type;
            target.MaxSpeed = from.MaxSpeed;
            target.MaxTorque = from.MaxTorque;
            target.MinRange = from.MinRange;
            target.MaxRange = from.MaxRange;
            target.CurrVal = from.CurrVal;
            target.CurrTorque = from.CurrTorque;
            target.DesiredVal = from.DesiredVal;
            target.DesiredOrder = from.DesiredOrder;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_MisStatus_TO_Microsoft_Robotics_Services_RoboCupGUI_MisStatus(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.MisStatus target = new Microsoft.Robotics.Services.RoboCupGUI.MisStatus();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.MisStatus from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.MisStatus;
            target.Name = from.Name;
            target.TimeStamp = from.TimeStamp;

            // copy IEnumerable Link
            if (from.Link != null)
            {
                target.Link = new System.Collections.Generic.List<Microsoft.Robotics.Services.RoboCupGUI.LinkProperty>();
                foreach(Microsoft.Robotics.Services.RoboCupGUI.Proxy.LinkProperty elem in from.Link)
                {
                    target.Link.Add((elem == null) ? null : (Microsoft.Robotics.Services.RoboCupGUI.LinkProperty)Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_LinkProperty_TO_Microsoft_Robotics_Services_RoboCupGUI_LinkProperty(elem));
                }
            }
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_MisStatus_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_MisStatus(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.MisStatus target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.MisStatus();
            Microsoft.Robotics.Services.RoboCupGUI.MisStatus from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.MisStatus;
            target.Name = from.Name;
            target.TimeStamp = from.TimeStamp;

            // copy IEnumerable Link
            if (from.Link != null)
            {
                target.Link = new System.Collections.Generic.List<Microsoft.Robotics.Services.RoboCupGUI.Proxy.LinkProperty>();
                foreach(Microsoft.Robotics.Services.RoboCupGUI.LinkProperty elem in from.Link)
                {
                    target.Link.Add((elem == null) ? null : (Microsoft.Robotics.Services.RoboCupGUI.Proxy.LinkProperty)Transform_Microsoft_Robotics_Services_RoboCupGUI_LinkProperty_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_LinkProperty(elem));
                }
            }
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_StartPoses_TO_Microsoft_Robotics_Services_RoboCupGUI_StartPoses(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.StartPoses target = new Microsoft.Robotics.Services.RoboCupGUI.StartPoses();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.StartPoses from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.StartPoses;
            target.Name = from.Name;
            target.xPos = from.xPos;
            target.yPos = from.yPos;
            target.zPos = from.zPos;
            target.xRot = from.xRot;
            target.yRot = from.yRot;
            target.zRot = from.zRot;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_StartPoses_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_StartPoses(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.StartPoses target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.StartPoses();
            Microsoft.Robotics.Services.RoboCupGUI.StartPoses from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.StartPoses;
            target.Name = from.Name;
            target.xPos = from.xPos;
            target.yPos = from.yPos;
            target.zPos = from.zPos;
            target.xRot = from.xRot;
            target.yRot = from.yRot;
            target.zRot = from.zRot;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_BotStatus_TO_Microsoft_Robotics_Services_RoboCupGUI_BotStatus(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.BotStatus target = new Microsoft.Robotics.Services.RoboCupGUI.BotStatus();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.BotStatus from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.BotStatus;
            target.Type = from.Type;
            target.TimeStamp = from.TimeStamp;
            target.LightOn = from.LightOn;
            target.LightIntensity = from.LightIntensity;
            target.Battery = from.Battery;
            target.ViewNum = from.ViewNum;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_BotStatus_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_BotStatus(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.BotStatus target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.BotStatus();
            Microsoft.Robotics.Services.RoboCupGUI.BotStatus from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.BotStatus;
            target.Type = from.Type;
            target.TimeStamp = from.TimeStamp;
            target.LightOn = from.LightOn;
            target.LightIntensity = from.LightIntensity;
            target.Battery = from.Battery;
            target.ViewNum = from.ViewNum;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_VictimLoc_TO_Microsoft_Robotics_Services_RoboCupGUI_VictimLoc(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.VictimLoc target = new Microsoft.Robotics.Services.RoboCupGUI.VictimLoc();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.VictimLoc from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.VictimLoc;
            target.Row = from.Row;
            target.Col = from.Col;
            target.xPos = from.xPos;
            target.yPos = from.yPos;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_VictimLoc_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_VictimLoc(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.VictimLoc target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.VictimLoc();
            Microsoft.Robotics.Services.RoboCupGUI.VictimLoc from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.VictimLoc;
            target.Row = from.Row;
            target.Col = from.Col;
            target.xPos = from.xPos;
            target.yPos = from.yPos;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_Point_TO_Microsoft_Robotics_Services_RoboCupGUI_Point(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Point target = new Microsoft.Robotics.Services.RoboCupGUI.Point();
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.Point from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Proxy.Point;
            target.X = from.X;
            target.Y = from.Y;
            return target;
        }


        public static object Transform_Microsoft_Robotics_Services_RoboCupGUI_Point_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_Point(object transformFrom)
        {
            Microsoft.Robotics.Services.RoboCupGUI.Proxy.Point target = new Microsoft.Robotics.Services.RoboCupGUI.Proxy.Point();
            Microsoft.Robotics.Services.RoboCupGUI.Point from = transformFrom as Microsoft.Robotics.Services.RoboCupGUI.Point;
            target.X = from.X;
            target.Y = from.Y;
            return target;
        }

        static Transforms()
        {
            Register();
        }
        public static void Register()
        {
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.RoboCupGUIState), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_RoboCupGUIState_TO_Microsoft_Robotics_Services_RoboCupGUI_RoboCupGUIState);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.RoboCupGUIState), Transform_Microsoft_Robotics_Services_RoboCupGUI_RoboCupGUIState_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_RoboCupGUIState);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.ConnectCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ConnectCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_ConnectCMDRequest);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.ConnectCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_ConnectCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ConnectCMDRequest);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.DisconnectCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_DisconnectCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_DisconnectCMDRequest);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.DisconnectCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_DisconnectCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_DisconnectCMDRequest);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.GetPosesCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GetPosesCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_GetPosesCMDRequest);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.GetPosesCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_GetPosesCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GetPosesCMDRequest);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.InitCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_InitCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_InitCMDRequest);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.InitCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_InitCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_InitCMDRequest);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.DriveAerialCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_DriveAerialCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_DriveAerialCMDRequest);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.DriveAerialCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_DriveAerialCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_DriveAerialCMDRequest);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.MisPkgCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_MisPkgCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_MisPkgCMDRequest);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.MisPkgCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_MisPkgCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_MisPkgCMDRequest);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.ImgSvrCamCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ImgSvrCamCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_ImgSvrCamCMDRequest);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.ImgSvrCamCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_ImgSvrCamCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ImgSvrCamCMDRequest);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.ImgSvrOKCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ImgSvrOKCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_ImgSvrOKCMDRequest);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.ImgSvrOKCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_ImgSvrOKCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ImgSvrOKCMDRequest);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.WaypointCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_WaypointCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_WaypointCMDRequest);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.WaypointCMDRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_WaypointCMDRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_WaypointCMDRequest);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.ConnectedMSGRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ConnectedMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_ConnectedMSGRequest);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.ConnectedMSGRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_ConnectedMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ConnectedMSGRequest);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.StartPosesMSGRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_StartPosesMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_StartPosesMSGRequest);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.StartPosesMSGRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_StartPosesMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_StartPosesMSGRequest);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.InitializedMSGRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_InitializedMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_InitializedMSGRequest);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.InitializedMSGRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_InitializedMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_InitializedMSGRequest);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.StaMSGRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_StaMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_StaMSGRequest);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.StaMSGRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_StaMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_StaMSGRequest);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.GPSMSGRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GPSMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_GPSMSGRequest);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.GPSMSGRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_GPSMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GPSMSGRequest);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.ImageMSGRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ImageMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_ImageMSGRequest);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.ImageMSGRequest), Transform_Microsoft_Robotics_Services_RoboCupGUI_ImageMSGRequest_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_ImageMSGRequest);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.GPS), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GPS_TO_Microsoft_Robotics_Services_RoboCupGUI_GPS);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.GPS), Transform_Microsoft_Robotics_Services_RoboCupGUI_GPS_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GPS);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.GroundTruth), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GroundTruth_TO_Microsoft_Robotics_Services_RoboCupGUI_GroundTruth);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.GroundTruth), Transform_Microsoft_Robotics_Services_RoboCupGUI_GroundTruth_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_GroundTruth);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.LinkProperty), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_LinkProperty_TO_Microsoft_Robotics_Services_RoboCupGUI_LinkProperty);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.LinkProperty), Transform_Microsoft_Robotics_Services_RoboCupGUI_LinkProperty_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_LinkProperty);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.MisStatus), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_MisStatus_TO_Microsoft_Robotics_Services_RoboCupGUI_MisStatus);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.MisStatus), Transform_Microsoft_Robotics_Services_RoboCupGUI_MisStatus_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_MisStatus);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.StartPoses), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_StartPoses_TO_Microsoft_Robotics_Services_RoboCupGUI_StartPoses);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.StartPoses), Transform_Microsoft_Robotics_Services_RoboCupGUI_StartPoses_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_StartPoses);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.BotStatus), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_BotStatus_TO_Microsoft_Robotics_Services_RoboCupGUI_BotStatus);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.BotStatus), Transform_Microsoft_Robotics_Services_RoboCupGUI_BotStatus_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_BotStatus);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.VictimLoc), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_VictimLoc_TO_Microsoft_Robotics_Services_RoboCupGUI_VictimLoc);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.VictimLoc), Transform_Microsoft_Robotics_Services_RoboCupGUI_VictimLoc_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_VictimLoc);
            AddProxyTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Proxy.Point), Transform_Microsoft_Robotics_Services_RoboCupGUI_Proxy_Point_TO_Microsoft_Robotics_Services_RoboCupGUI_Point);
            AddSourceTransform(typeof(Microsoft.Robotics.Services.RoboCupGUI.Point), Transform_Microsoft_Robotics_Services_RoboCupGUI_Point_TO_Microsoft_Robotics_Services_RoboCupGUI_Proxy_Point);
        }
    }
}

