//-----------------------------------------------------------------------
//  This file is part of the UC Merced Microsoft Robotics Developer Studio 
// Project Code Base.
//
//  Created by Benjamin Balaguer under the supervision of Stefano Carpin.
//  Based on SimpleDashboardState.cs from UX\SimpleDashboard.
//
//  $File: RoboCup2009GUIState.cs $
//-----------------------------------------------------------------------

using Microsoft.Dss.Core.Attributes;
using System;
using System.Collections.Generic;

namespace Microsoft.Robotics.Services.RoboCup2009GUI
{
    /// <summary>
    /// RoboCup2009GUI StateType
    /// </summary>
    [DataContract]
    public class RoboCup2009GUIState
    {
        [DataMember]
        public float TimeStamp;

        [DataMember]
        public float xPos;

        [DataMember]
        public float yPos;
    }
}
