/*
*	New C++ Header  File starts here.
*	This file should be named ../../include/sensorData_n_codegen_protos.hh
*/

#ifndef ______include_sensorData_n_codegen_protos_hh_included
#define ______include_sensorData_n_codegen_protos_hh_included

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "sensorData.hh"
#include "moastTypes.hh"
#include "moastNmlOffsets.hh"

// Forward Function Prototypes
extern void nmlupdate(CMS *cms, FeatInfo *x);
extern void nmlupdate(CMS *cms, HazardInfo *x);
extern void initialize_HazardInfo(HazardInfo *x);
extern void nmlupdate(CMS *cms, Location2D *x);
extern void nmlupdate(CMS *cms, SensorDataArrayElement *x);
extern void initialize_SensorDataArrayElement(SensorDataArrayElement *x);
extern void nmlupdate(CMS *cms, DataArrayElement *x);
extern void nmlupdate(CMS *cms, SensorPoint *x);
extern void initialize_DataArrayElement(DataArrayElement *x);
extern void initialize_FeatInfo(FeatInfo *x);
extern void nmlupdate(CMS *cms, IEDInfo *x);
extern void initialize_IEDInfo(IEDInfo *x);


#ifndef MAX_SENSORDATA_NAME_LENGTH
#define MAX_SENSORDATA_NAME_LENGTH 20
#endif
#ifndef SENSORDATA_NAME_LIST_LENGTH
#define SENSORDATA_NAME_LIST_LENGTH 11
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
extern const NMLTYPE sensorData_id_list[SENSORDATA_NAME_LIST_LENGTH];
extern const size_t sensorData_size_list[SENSORDATA_NAME_LIST_LENGTH];

// Enumerated Type Constants

extern int sensorData_format(NMLTYPE type, void *buffer, CMS *cms);

#endif
	/* # endif ______include_sensorData_n_codegen_protos_hh_included */ 

