/*
*	New C++ Header  File starts here.
*	This file should be named ../../include/servoMobJA_n_codegen_protos.hh
*/

#ifndef ______include_servoMobJA_n_codegen_protos_hh_included
#define ______include_servoMobJA_n_codegen_protos_hh_included

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "servoMobJA.hh"
#include "moastTypes.hh"
#include "moastNmlOffsets.hh"

// Forward Function Prototypes
extern void nmlupdate(CMS *cms, ServoMobJAFlipperMsg *x);
extern void initialize_ServoMobJAFlipperMsg(ServoMobJAFlipperMsg *x);
extern void nmlupdate(CMS *cms, ServoMobJAFlipperSet *x);
extern void initialize_ServoMobJAFlipperSet(ServoMobJAFlipperSet *x);


#ifndef MAX_SERVOMOBJA_NAME_LENGTH
#define MAX_SERVOMOBJA_NAME_LENGTH 24
#endif
#ifndef SERVOMOBJA_NAME_LIST_LENGTH
#define SERVOMOBJA_NAME_LIST_LENGTH 20
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
extern const NMLTYPE servoMobJA_id_list[SERVOMOBJA_NAME_LIST_LENGTH];
extern const size_t servoMobJA_size_list[SERVOMOBJA_NAME_LIST_LENGTH];

// Enumerated Type Constants

extern int servoMobJA_format(NMLTYPE type, void *buffer, CMS *cms);

#endif
	/* # endif ______include_servoMobJA_n_codegen_protos_hh_included */ 

