/*
*	New C++ Header  File starts here.
*	This file should be named ../../include/vehMobPL_n_codegen_protos.hh
*/

#ifndef ______include_vehMobPL_n_codegen_protos_hh_included
#define ______include_vehMobPL_n_codegen_protos_hh_included

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "vehMobPL.hh"
#include "moastNmlOffsets.hh"
#include "moastTypes.hh"

// Forward Function Prototypes
extern void nmlupdate(CMS *cms, roadPoint *x);
extern void initialize_roadPoint(roadPoint *x);
extern void nmlupdate(CMS *cms, constrainedInt *x);
extern void nmlupdate(CMS *cms, constrainedFloat *x);
extern void nmlupdate(CMS *cms, goalPoint *x);
extern void initialize_goalPoint(goalPoint *x);


#ifndef MAX_VEHMOBPL_NAME_LENGTH
#define MAX_VEHMOBPL_NAME_LENGTH 24
#endif
#ifndef VEHMOBPL_NAME_LIST_LENGTH
#define VEHMOBPL_NAME_LIST_LENGTH 29
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
extern const NMLTYPE vehMobPL_id_list[VEHMOBPL_NAME_LIST_LENGTH];
extern const size_t vehMobPL_size_list[VEHMOBPL_NAME_LIST_LENGTH];

// Enumerated Type Constants

extern int vehMobPL_format(NMLTYPE type, void *buffer, CMS *cms);

#endif
	/* # endif ______include_vehMobPL_n_codegen_protos_hh_included */ 

