/*
*	New C++ File starts here.
*	This file should be named primMisJA.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "primMisJA.hh"
#include "moastNmlOffsets.hh"

// Include externally supplied prototypes
#include "../../include/primMisJA_n_codegen_protos.hh"



#ifndef PRIMMISJA_NAME_LIST_LENGTH
#define PRIMMISJA_NAME_LIST_LENGTH 17
#endif

const NMLTYPE primMisJA_id_list[PRIMMISJA_NAME_LIST_LENGTH]= {
	PRIM_MIS_JA_CFG_CYCLE_TIME_TYPE, /* 0,7202 */
	PRIM_MIS_JA_CFG_DEBUG_TYPE, /* 1,7203 */
	PRIM_MIS_JA_CFG_MOVE_TYPE, /* 2,7204 */
	PRIM_MIS_JA_CFG_NOP_TYPE, /* 3,7201 */
	PRIM_MIS_JA_CMD_ABORT_TYPE, /* 4,7003 */
	PRIM_MIS_JA_CMD_HALT_TYPE, /* 5,7004 */
	PRIM_MIS_JA_CMD_HOME_TYPE, /* 6,7007 */
	PRIM_MIS_JA_CMD_INIT_TYPE, /* 7,7002 */
	PRIM_MIS_JA_CMD_MOVE_TYPE, /* 8,7006 */
	PRIM_MIS_JA_CMD_NOP_TYPE, /* 9,7001 */
	PRIM_MIS_JA_CMD_PAN_TYPE, /* 10,7009 */
	PRIM_MIS_JA_CMD_SCAN_TYPE, /* 11,7008 */
	PRIM_MIS_JA_CMD_SHUTDOWN_TYPE, /* 12,7005 */
	PRIM_MIS_JA_CMD_TILT_TYPE, /* 13,7010 */
	PRIM_MIS_JA_SET_TYPE, /* 14,7301 */
	PRIM_MIS_JA_STAT_TYPE, /* 15,7101 */
	-1};
const size_t primMisJA_size_list[PRIMMISJA_NAME_LIST_LENGTH]= {
	sizeof(PrimMisJACfgCycleTime),
	sizeof(PrimMisJACfgDebug),
	sizeof(PrimMisJACfgMove),
	sizeof(PrimMisJACfgNop),
	sizeof(PrimMisJACmdAbort),
	sizeof(PrimMisJACmdHalt),
	sizeof(PrimMisJACmdHome),
	sizeof(PrimMisJACmdInit),
	sizeof(PrimMisJACmdMove),
	sizeof(PrimMisJACmdNop),
	sizeof(PrimMisJACmdPan),
	sizeof(PrimMisJACmdScan),
	sizeof(PrimMisJACmdShutdown),
	sizeof(PrimMisJACmdTilt),
	sizeof(PrimMisJASet),
	sizeof(PrimMisJAStat),
	0};


// Enumerated Type Constants

/*
Estimated_size	PrimMisJACfgCycleTime	32
Estimated_size	PrimMisJACfgDebug	32
Estimated_size	PrimMisJACfgMove	56
Estimated_size	PrimMisJACfgNop	24
Estimated_size	PrimMisJACmdAbort	24
Estimated_size	PrimMisJACmdHalt	24
Estimated_size	PrimMisJACmdHome	24
Estimated_size	PrimMisJACmdInit	24
Estimated_size	PrimMisJACmdMove	48
Estimated_size	PrimMisJACmdNop	24
Estimated_size	PrimMisJACmdPan	56
Estimated_size	PrimMisJACmdScan	72
Estimated_size	PrimMisJACmdShutdown	24
Estimated_size	PrimMisJACmdTilt	56
Estimated_size	PrimMisJASet	232
Estimated_size	PrimMisJAStat	336
Estimated_size	MAXIMUM	336
*/
/*
*	NML/CMS Format function : primMisJA_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
int primMisJA_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"primMisJA",
		(cms_symbol_lookup_function_t) 0,
		(const char **) 0,
		primMisJA_id_list,primMisJA_size_list,
		PRIMMISJA_NAME_LIST_LENGTH,
		0);

	switch(type)
	{
	case PRIM_MIS_JA_CFG_CYCLE_TIME_TYPE:
		((PrimMisJACfgCycleTime *) buffer)->update(cms);
		break;
	case PRIM_MIS_JA_CFG_DEBUG_TYPE:
		((PrimMisJACfgDebug *) buffer)->update(cms);
		break;
	case PRIM_MIS_JA_CFG_MOVE_TYPE:
		((PrimMisJACfgMove *) buffer)->update(cms);
		break;
	case PRIM_MIS_JA_CFG_NOP_TYPE:
		((PrimMisJACfgNop *) buffer)->update(cms);
		break;
	case PRIM_MIS_JA_CMD_ABORT_TYPE:
		((PrimMisJACmdAbort *) buffer)->update(cms);
		break;
	case PRIM_MIS_JA_CMD_HALT_TYPE:
		((PrimMisJACmdHalt *) buffer)->update(cms);
		break;
	case PRIM_MIS_JA_CMD_HOME_TYPE:
		((PrimMisJACmdHome *) buffer)->update(cms);
		break;
	case PRIM_MIS_JA_CMD_INIT_TYPE:
		((PrimMisJACmdInit *) buffer)->update(cms);
		break;
	case PRIM_MIS_JA_CMD_MOVE_TYPE:
		((PrimMisJACmdMove *) buffer)->update(cms);
		break;
	case PRIM_MIS_JA_CMD_NOP_TYPE:
		((PrimMisJACmdNop *) buffer)->update(cms);
		break;
	case PRIM_MIS_JA_CMD_PAN_TYPE:
		((PrimMisJACmdPan *) buffer)->update(cms);
		break;
	case PRIM_MIS_JA_CMD_SCAN_TYPE:
		((PrimMisJACmdScan *) buffer)->update(cms);
		break;
	case PRIM_MIS_JA_CMD_SHUTDOWN_TYPE:
		((PrimMisJACmdShutdown *) buffer)->update(cms);
		break;
	case PRIM_MIS_JA_CMD_TILT_TYPE:
		((PrimMisJACmdTilt *) buffer)->update(cms);
		break;
	case PRIM_MIS_JA_SET_TYPE:
		((PrimMisJASet *) buffer)->update(cms);
		break;
	case PRIM_MIS_JA_STAT_TYPE:
		((PrimMisJAStat *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}

/*
*	NML/CMS Update function for PrimMisJACfgCycleTime
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJACfgCycleTime::update(CMS *cms)
{

	cms->beginClass("PrimMisJACfgCycleTime","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);

	cms->endClass("PrimMisJACfgCycleTime","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMisJACfgDebug
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJACfgDebug::update(CMS *cms)
{

	cms->beginClass("PrimMisJACfgDebug","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("debug",debug);

	cms->endClass("PrimMisJACfgDebug","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMisJACfgMove
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJACfgMove::update(CMS *cms)
{

	cms->beginClass("PrimMisJACfgMove","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("maxVel",maxVel);
	cms->update_with_name("maxAcc",maxAcc);
	cms->update_with_name("minLimit",minLimit);
	cms->update_with_name("maxLimit",maxLimit);

	cms->endClass("PrimMisJACfgMove","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMisJACfgNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJACfgNop::update(CMS *cms)
{

	cms->beginClass("PrimMisJACfgNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMisJACfgNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMisJACmdAbort
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJACmdAbort::update(CMS *cms)
{

	cms->beginClass("PrimMisJACmdAbort","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMisJACmdAbort","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMisJACmdHalt
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJACmdHalt::update(CMS *cms)
{

	cms->beginClass("PrimMisJACmdHalt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMisJACmdHalt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMisJACmdHome
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJACmdHome::update(CMS *cms)
{

	cms->beginClass("PrimMisJACmdHome","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMisJACmdHome","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMisJACmdInit
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJACmdInit::update(CMS *cms)
{

	cms->beginClass("PrimMisJACmdInit","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMisJACmdInit","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMisJACmdMove
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJACmdMove::update(CMS *cms)
{

	cms->beginClass("PrimMisJACmdMove","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("pan",pan);
	cms->update_with_name("tilt",tilt);
	cms->update_with_name("time",time);

	cms->endClass("PrimMisJACmdMove","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMisJACmdNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJACmdNop::update(CMS *cms)
{

	cms->beginClass("PrimMisJACmdNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMisJACmdNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMisJACmdPan
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJACmdPan::update(CMS *cms)
{

	cms->beginClass("PrimMisJACmdPan","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("panStart",panStart);
	cms->update_with_name("panEnd",panEnd);
	cms->update_with_name("tilt",tilt);
	cms->update_with_name("time",time);

	cms->endClass("PrimMisJACmdPan","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMisJACmdScan
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJACmdScan::update(CMS *cms)
{

	cms->beginClass("PrimMisJACmdScan","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("panStart",panStart);
	cms->update_with_name("panEnd",panEnd);
	cms->update_with_name("tiltStart",tiltStart);
	cms->update_with_name("tiltEnd",tiltEnd);
	cms->update_with_name("fraction",fraction);
	cms->update_with_name("time",time);

	cms->endClass("PrimMisJACmdScan","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMisJACmdShutdown
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJACmdShutdown::update(CMS *cms)
{

	cms->beginClass("PrimMisJACmdShutdown","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMisJACmdShutdown","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMisJACmdTilt
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJACmdTilt::update(CMS *cms)
{

	cms->beginClass("PrimMisJACmdTilt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("tiltStart",tiltStart);
	cms->update_with_name("tiltEnd",tiltEnd);
	cms->update_with_name("pan",pan);
	cms->update_with_name("time",time);

	cms->endClass("PrimMisJACmdTilt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMisJASet
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJASet::update(CMS *cms)
{

	cms->beginClass("PrimMisJASet","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);
	cms->update_with_name("debug",debug);
	cms->update_with_name("maxVel",maxVel);
	cms->update_with_name("maxAcc",maxAcc);
	cms->update_with_name("minLimit",minLimit);
	cms->update_with_name("maxLimit",maxLimit);
	cms->update_with_name("pose",pose);

	cms->endClass("PrimMisJASet","RCS_STAT_MSG");

}


/*
*	NML/CMS Update function for PrimMisJAStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:55 PDT 2008
*/
void PrimMisJAStat::update(CMS *cms)
{

	cms->beginClass("PrimMisJAStat","RCS_STAT_MSG_V2");

	cms->beginBaseClass("RCS_STAT_MSG_V2");
	RCS_STAT_MSG_V2::update(cms);
	cms->endBaseClass("RCS_STAT_MSG_V2");

	cms->update_with_name("timestamp",timestamp);
	cms->update_with_name("pan",pan);
	cms->update_with_name("tilt",tilt);
	cms->update_with_name("homed",homed);
	cms->update_with_name("inpos",inpos);

	cms->endClass("PrimMisJAStat","RCS_STAT_MSG_V2");

}

