/*
*	New C++ File starts here.
*	This file should be named sectMobPL.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "sectMobPL.hh"
#include "moastNmlOffsets.hh"
#include "moastTypes.hh"

// Include externally supplied prototypes
#include "../../include/sectMobPL_n_codegen_protos.hh"



#ifndef SECTMOBPL_NAME_LIST_LENGTH
#define SECTMOBPL_NAME_LIST_LENGTH 22
#endif

const NMLTYPE sectMobPL_id_list[SECTMOBPL_NAME_LIST_LENGTH]= {
	SECT_MOB_PL_CFG_CLEAR_WM_TYPE, /* 0,16204 */
	SECT_MOB_PL_CFG_CYCLE_TIME_TYPE, /* 1,16201 */
	SECT_MOB_PL_CFG_DEBUG_TYPE, /* 2,16202 */
	SECT_MOB_PL_CFG_DUMP_WM_TYPE, /* 3,16206 */
	SECT_MOB_PL_CFG_LOAD_WM_TYPE, /* 4,16207 */
	SECT_MOB_PL_CFG_NOP_TYPE, /* 5,16203 */
	SECT_MOB_PL_CFG_STORE_WM_TYPE, /* 6,16205 */
	SECT_MOB_PL_CMD_ABORT_TYPE, /* 7,16002 */
	SECT_MOB_PL_CMD_CONNECT_TYPE, /* 8,16007 */
	SECT_MOB_PL_CMD_CRASH_TYPE, /* 9,16009 */
	SECT_MOB_PL_CMD_DELIVER_TYPE, /* 10,16011 */
	SECT_MOB_PL_CMD_DISCONNECT_TYPE, /* 11,16008 */
	SECT_MOB_PL_CMD_EXPLORE_TYPE, /* 12,16006 */
	SECT_MOB_PL_CMD_HALT_TYPE, /* 13,16003 */
	SECT_MOB_PL_CMD_INIT_TYPE, /* 14,16001 */
	SECT_MOB_PL_CMD_LOAD_WM_TYPE, /* 15,16010 */
	SECT_MOB_PL_CMD_NOP_TYPE, /* 16,16005 */
	SECT_MOB_PL_CMD_SHUTDOWN_TYPE, /* 17,16004 */
	SECT_MOB_PL_CMD_WAYPOINT_TYPE, /* 18,16012 */
	SECT_MOB_PL_SET_TYPE, /* 19,16301 */
	SECT_MOB_PL_STAT_TYPE, /* 20,16101 */
	-1};
const size_t sectMobPL_size_list[SECTMOBPL_NAME_LIST_LENGTH]= {
	sizeof(SectMobPLCfgClearWM),
	sizeof(SectMobPLCfgCycleTime),
	sizeof(SectMobPLCfgDebug),
	sizeof(SectMobPLCfgDumpWM),
	sizeof(SectMobPLCfgLoadWM),
	sizeof(SectMobPLCfgNop),
	sizeof(SectMobPLCfgStoreWM),
	sizeof(SectMobPLCmdAbort),
	sizeof(SectMobPLCmdConnect),
	sizeof(SectMobPLCmdCrash),
	sizeof(SectMobPLCmdDeliver),
	sizeof(SectMobPLCmdDisconnect),
	sizeof(SectMobPLCmdExplore),
	sizeof(SectMobPLCmdHalt),
	sizeof(SectMobPLCmdInit),
	sizeof(SectMobPLCmdLoadWM),
	sizeof(SectMobPLCmdNop),
	sizeof(SectMobPLCmdShutdown),
	sizeof(SectMobPLCmdWaypoint),
	sizeof(SectMobPLSet),
	sizeof(SectMobPLStat),
	0};


// Enumerated Type Constants

/*
Estimated_size	SectMobPLCfgClearWM	24
Estimated_size	SectMobPLCfgCycleTime	32
Estimated_size	SectMobPLCfgDebug	32
Estimated_size	SectMobPLCfgDumpWM	121
Estimated_size	SectMobPLCfgLoadWM	104
Estimated_size	SectMobPLCfgNop	24
Estimated_size	SectMobPLCfgStoreWM	104
Estimated_size	SectMobPLCmdAbort	24
Estimated_size	SectMobPLCmdConnect	73
Estimated_size	SectMobPLCmdCrash	32
Estimated_size	SectMobPLCmdDeliver	24
Estimated_size	SectMobPLCmdDisconnect	26
Estimated_size	SectMobPLCmdExplore	40
Estimated_size	SectMobPLCmdHalt	24
Estimated_size	SectMobPLCmdInit	80
Estimated_size	SectMobPLCmdLoadWM	104
Estimated_size	SectMobPLCmdNop	24
Estimated_size	SectMobPLCmdShutdown	24
Estimated_size	SectMobPLCmdWaypoint	105
Estimated_size	SectMobPLSet	424
Estimated_size	SectMobPLStat	396
Estimated_size	MAXIMUM	424
*/
/*
*	NML/CMS Format function : sectMobPL_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
int sectMobPL_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"sectMobPL",
		(cms_symbol_lookup_function_t) 0,
		(const char **) 0,
		sectMobPL_id_list,sectMobPL_size_list,
		SECTMOBPL_NAME_LIST_LENGTH,
		0);

	switch(type)
	{
	case SECT_MOB_PL_CFG_CLEAR_WM_TYPE:
		((SectMobPLCfgClearWM *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CFG_CYCLE_TIME_TYPE:
		((SectMobPLCfgCycleTime *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CFG_DEBUG_TYPE:
		((SectMobPLCfgDebug *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CFG_DUMP_WM_TYPE:
		((SectMobPLCfgDumpWM *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CFG_LOAD_WM_TYPE:
		((SectMobPLCfgLoadWM *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CFG_NOP_TYPE:
		((SectMobPLCfgNop *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CFG_STORE_WM_TYPE:
		((SectMobPLCfgStoreWM *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CMD_ABORT_TYPE:
		((SectMobPLCmdAbort *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CMD_CONNECT_TYPE:
		((SectMobPLCmdConnect *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CMD_CRASH_TYPE:
		((SectMobPLCmdCrash *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CMD_DELIVER_TYPE:
		((SectMobPLCmdDeliver *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CMD_DISCONNECT_TYPE:
		((SectMobPLCmdDisconnect *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CMD_EXPLORE_TYPE:
		((SectMobPLCmdExplore *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CMD_HALT_TYPE:
		((SectMobPLCmdHalt *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CMD_INIT_TYPE:
		((SectMobPLCmdInit *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CMD_LOAD_WM_TYPE:
		((SectMobPLCmdLoadWM *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CMD_NOP_TYPE:
		((SectMobPLCmdNop *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CMD_SHUTDOWN_TYPE:
		((SectMobPLCmdShutdown *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_CMD_WAYPOINT_TYPE:
		((SectMobPLCmdWaypoint *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_SET_TYPE:
		((SectMobPLSet *) buffer)->update(cms);
		break;
	case SECT_MOB_PL_STAT_TYPE:
		((SectMobPLStat *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}

/*
*	NML/CMS Update function for SectMobPLCfgClearWM
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCfgClearWM::update(CMS *cms)
{

	cms->beginClass("SectMobPLCfgClearWM","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("SectMobPLCfgClearWM","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCfgCycleTime
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCfgCycleTime::update(CMS *cms)
{

	cms->beginClass("SectMobPLCfgCycleTime","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);

	cms->endClass("SectMobPLCfgCycleTime","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCfgDebug
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCfgDebug::update(CMS *cms)
{

	cms->beginClass("SectMobPLCfgDebug","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("debug",debug);

	cms->endClass("SectMobPLCfgDebug","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCfgDumpWM
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCfgDumpWM::update(CMS *cms)
{

	cms->beginClass("SectMobPLCfgDumpWM","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("fileName",fileName,80);
	cms->update_with_name("dumpContinuous",dumpContinuous);
	cms->update_with_name("skip",skip);
	cms->update_with_name("turnOn",turnOn);

	cms->endClass("SectMobPLCfgDumpWM","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCfgLoadWM
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCfgLoadWM::update(CMS *cms)
{

	cms->beginClass("SectMobPLCfgLoadWM","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("fileName",fileName,80);

	cms->endClass("SectMobPLCfgLoadWM","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCfgNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCfgNop::update(CMS *cms)
{

	cms->beginClass("SectMobPLCfgNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("SectMobPLCfgNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCfgStoreWM
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCfgStoreWM::update(CMS *cms)
{

	cms->beginClass("SectMobPLCfgStoreWM","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("fileName",fileName,80);

	cms->endClass("SectMobPLCfgStoreWM","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCmdAbort
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCmdAbort::update(CMS *cms)
{

	cms->beginClass("SectMobPLCmdAbort","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("SectMobPLCmdAbort","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCmdConnect
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCmdConnect::update(CMS *cms)
{

	cms->beginClass("SectMobPLCmdConnect","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_dla_length_with_name("vehID_length",vehID_length);
	cms->update_dla_with_name("vehID",vehID,vehID_length,4);
	cms->update_with_name("doSendInit",doSendInit);

	cms->endClass("SectMobPLCmdConnect","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCmdCrash
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCmdCrash::update(CMS *cms)
{

	cms->beginClass("SectMobPLCmdCrash","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("driverReact",driverReact);
	cms->update_with_name("warnDist",warnDist);

	cms->endClass("SectMobPLCmdCrash","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCmdDeliver
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCmdDeliver::update(CMS *cms)
{

	cms->beginClass("SectMobPLCmdDeliver","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("SectMobPLCmdDeliver","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCmdDisconnect
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCmdDisconnect::update(CMS *cms)
{

	cms->beginClass("SectMobPLCmdDisconnect","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("doSendHalt",doSendHalt);
	cms->update_with_name("doSendShutdown",doSendShutdown);

	cms->endClass("SectMobPLCmdDisconnect","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCmdExplore
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCmdExplore::update(CMS *cms)
{

	cms->beginClass("SectMobPLCmdExplore","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("exploreDist",exploreDist);
	cms->update_with_name("maxCost",maxCost);

	cms->endClass("SectMobPLCmdExplore","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCmdHalt
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCmdHalt::update(CMS *cms)
{

	cms->beginClass("SectMobPLCmdHalt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("SectMobPLCmdHalt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCmdInit
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCmdInit::update(CMS *cms)
{

	cms->beginClass("SectMobPLCmdInit","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	subordinate= (enum SectSubordinate) cms->update_enumeration_with_name("subordinate", (int)subordinate,(void*)&subordinate,0);
	cms->update_dla_length_with_name("vehList_length",vehList_length);
	cms->update_dla_with_name("vehList",vehList,vehList_length,4);

	cms->endClass("SectMobPLCmdInit","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCmdLoadWM
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCmdLoadWM::update(CMS *cms)
{

	cms->beginClass("SectMobPLCmdLoadWM","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("fileName",fileName,80);

	cms->endClass("SectMobPLCmdLoadWM","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCmdNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCmdNop::update(CMS *cms)
{

	cms->beginClass("SectMobPLCmdNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("SectMobPLCmdNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCmdShutdown
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCmdShutdown::update(CMS *cms)
{

	cms->beginClass("SectMobPLCmdShutdown","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("SectMobPLCmdShutdown","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLCmdWaypoint
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLCmdWaypoint::update(CMS *cms)
{

	cms->beginClass("SectMobPLCmdWaypoint","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("fileName",fileName,80);
	cms->update_with_name("repeat",repeat);

	cms->endClass("SectMobPLCmdWaypoint","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for SectMobPLSet
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLSet::update(CMS *cms)
{

	cms->beginClass("SectMobPLSet","RCS_STAT_MSG_V2");

	cms->beginBaseClass("RCS_STAT_MSG_V2");
	RCS_STAT_MSG_V2::update(cms);
	cms->endBaseClass("RCS_STAT_MSG_V2");

	cms->update_with_name("cycleTime",cycleTime);
	cms->update_with_name("debug",debug);
	cms->update_with_name("wmFileName",wmFileName,80);
	cms->update_with_name("fileSkip",fileSkip);
	cms->update_with_name("worldResolution",worldResolution);
	cms->update_with_name("worldHeight",worldHeight);
	cms->update_with_name("worldWidth",worldWidth);

	cms->endClass("SectMobPLSet","RCS_STAT_MSG_V2");

}


/*
*	NML/CMS Update function for SectMobPLStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:36:00 PDT 2008
*/
void SectMobPLStat::update(CMS *cms)
{

	cms->beginClass("SectMobPLStat","RCS_STAT_MSG_V2");

	cms->beginBaseClass("RCS_STAT_MSG_V2");
	RCS_STAT_MSG_V2::update(cms);
	cms->endBaseClass("RCS_STAT_MSG_V2");

	cms->update_with_name("heartbeat",heartbeat);
	cms->update_with_name("numVehicles",numVehicles);
	subordinate= (enum SectSubordinate) cms->update_enumeration_with_name("subordinate", (int)subordinate,(void*)&subordinate,0);
	cms->update_with_name("message",message,80);

	cms->endClass("SectMobPLStat","RCS_STAT_MSG_V2");

}

