/*
*	New C++ File starts here.
*	This file should be named moastTypes.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "moastTypes.hh"
#include "moastNmlOffsets.hh"
#include "navDataExt.hh"

// Forward Function Prototypes


#ifndef MAX_NAVDATAEXT_NAME_LENGTH
#define MAX_NAVDATAEXT_NAME_LENGTH 11
#endif
#ifndef NAVDATAEXT_NAME_LIST_LENGTH
#define NAVDATAEXT_NAME_LIST_LENGTH 2
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
const char navDataExt_name_list[NAVDATAEXT_NAME_LIST_LENGTH][MAX_NAVDATAEXT_NAME_LENGTH]= {
	"NavDataExt", /* 0,1001 */
	""};
const NMLTYPE navDataExt_id_list[NAVDATAEXT_NAME_LIST_LENGTH]= {
	NAV_DATA_EXT_TYPE, /* 0,1001 */
	-1};
const size_t navDataExt_size_list[NAVDATAEXT_NAME_LIST_LENGTH]= {
	sizeof(NavDataExt),
	0};
const char *navDataExt_symbol_lookup(long type);


// Enumerated Type Constants

// anonymous_enum_______include_moastTypes_hh_288
#ifndef MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_STRING_LENGTH
#define MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_STRING_LENGTH 17
#endif
#ifndef ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_LENGTH
#define ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_LENGTH 3
#endif

static const char enum_anonymous_enum_______include_moastTypes_hh_288_string_list[ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_LENGTH][MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_STRING_LENGTH]= {
	"MOAST_ROTATE_CCW", /* 0,1 */
	"MOAST_ROTATE_CW", /* 1,0 */
	""};

static const int enum_anonymous_enum_______include_moastTypes_hh_288_int_list[ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_LENGTH]= {
	MOAST_ROTATE_CCW, /* 0,1 */
	MOAST_ROTATE_CW, /* 1,0 */
	};

const char *navDataExt_enum_anonymous_enum_______include_moastTypes_hh_288_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_ROTATE_CCW: return("MOAST_ROTATE_CCW"); /* 1 */
		case MOAST_ROTATE_CW: return("MOAST_ROTATE_CW"); /* 0 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_anonymous_enum_______include_moastTypes_hh_288_info_struct={
	"anonymous_enum_______include_moastTypes_hh_288",
	(const char **)enum_anonymous_enum_______include_moastTypes_hh_288_string_list,
	enum_anonymous_enum_______include_moastTypes_hh_288_int_list,
	MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_STRING_LENGTH,
	ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_LENGTH,
	(cms_symbol_lookup_function_t)navDataExt_enum_anonymous_enum_______include_moastTypes_hh_288_symbol_lookup
	};

// moastSteerType
#ifndef MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH 29
#endif
#ifndef ENUM_MOASTSTEERTYPE_LENGTH
#define ENUM_MOASTSTEERTYPE_LENGTH 9
#endif

static const char enum_moastSteerType_string_list[ENUM_MOASTSTEERTYPE_LENGTH][MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH]= {
	"MOAST_ACKERMAN_STEER_TYPE", /* 0,1 */
	"MOAST_FIXED_WING_STEER_TYPE", /* 1,5 */
	"MOAST_INVALID_STEER_TYPE", /* 2,-1 */
	"MOAST_OMNI_STEER_TYPE", /* 3,2 */
	"MOAST_ROTARY_WING_STEER_TYPE", /* 4,4 */
	"MOAST_SKID_STEER_TYPE", /* 5,0 */
	"MOAST_SUBMARINE_STEER_TYPE", /* 6,3 */
	"MOAST_UNKNOWN_STEER_TYPE", /* 7,6 */
	""};

static const int enum_moastSteerType_int_list[ENUM_MOASTSTEERTYPE_LENGTH]= {
	MOAST_ACKERMAN_STEER_TYPE, /* 0,1 */
	MOAST_FIXED_WING_STEER_TYPE, /* 1,5 */
	MOAST_INVALID_STEER_TYPE, /* 2,-1 */
	MOAST_OMNI_STEER_TYPE, /* 3,2 */
	MOAST_ROTARY_WING_STEER_TYPE, /* 4,4 */
	MOAST_SKID_STEER_TYPE, /* 5,0 */
	MOAST_SUBMARINE_STEER_TYPE, /* 6,3 */
	MOAST_UNKNOWN_STEER_TYPE, /* 7,6 */
	};

const char *navDataExt_enum_moastSteerType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_ACKERMAN_STEER_TYPE: return("MOAST_ACKERMAN_STEER_TYPE"); /* 1 */
		case MOAST_FIXED_WING_STEER_TYPE: return("MOAST_FIXED_WING_STEER_TYPE"); /* 5 */
		case MOAST_INVALID_STEER_TYPE: return("MOAST_INVALID_STEER_TYPE"); /* -1 */
		case MOAST_OMNI_STEER_TYPE: return("MOAST_OMNI_STEER_TYPE"); /* 2 */
		case MOAST_ROTARY_WING_STEER_TYPE: return("MOAST_ROTARY_WING_STEER_TYPE"); /* 4 */
		case MOAST_SKID_STEER_TYPE: return("MOAST_SKID_STEER_TYPE"); /* 0 */
		case MOAST_SUBMARINE_STEER_TYPE: return("MOAST_SUBMARINE_STEER_TYPE"); /* 3 */
		case MOAST_UNKNOWN_STEER_TYPE: return("MOAST_UNKNOWN_STEER_TYPE"); /* 6 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastSteerType_info_struct={
	"moastSteerType",
	(const char **)enum_moastSteerType_string_list,
	enum_moastSteerType_int_list,
	MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH,
	ENUM_MOASTSTEERTYPE_LENGTH,
	(cms_symbol_lookup_function_t)navDataExt_enum_moastSteerType_symbol_lookup
	};

// moastFlipperType
#ifndef MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH 22
#endif
#ifndef ENUM_MOASTFLIPPERTYPE_LENGTH
#define ENUM_MOASTFLIPPERTYPE_LENGTH 5
#endif

static const char enum_moastFlipperType_string_list[ENUM_MOASTFLIPPERTYPE_LENGTH][MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH]= {
	"MOAST_FL_FLIPPER_TYPE", /* 0,1 */
	"MOAST_FR_FLIPPER_TYPE", /* 1,0 */
	"MOAST_RL_FLIPPER_TYPE", /* 2,3 */
	"MOAST_RR_FLIPPER_TYPE", /* 3,2 */
	""};

static const int enum_moastFlipperType_int_list[ENUM_MOASTFLIPPERTYPE_LENGTH]= {
	MOAST_FL_FLIPPER_TYPE, /* 0,1 */
	MOAST_FR_FLIPPER_TYPE, /* 1,0 */
	MOAST_RL_FLIPPER_TYPE, /* 2,3 */
	MOAST_RR_FLIPPER_TYPE, /* 3,2 */
	};

const char *navDataExt_enum_moastFlipperType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_FL_FLIPPER_TYPE: return("MOAST_FL_FLIPPER_TYPE"); /* 1 */
		case MOAST_FR_FLIPPER_TYPE: return("MOAST_FR_FLIPPER_TYPE"); /* 0 */
		case MOAST_RL_FLIPPER_TYPE: return("MOAST_RL_FLIPPER_TYPE"); /* 3 */
		case MOAST_RR_FLIPPER_TYPE: return("MOAST_RR_FLIPPER_TYPE"); /* 2 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastFlipperType_info_struct={
	"moastFlipperType",
	(const char **)enum_moastFlipperType_string_list,
	enum_moastFlipperType_int_list,
	MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH,
	ENUM_MOASTFLIPPERTYPE_LENGTH,
	(cms_symbol_lookup_function_t)navDataExt_enum_moastFlipperType_symbol_lookup
	};

// moastRobotType
#ifndef MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH 26
#endif
#ifndef ENUM_MOASTROBOTTYPE_LENGTH
#define ENUM_MOASTROBOTTYPE_LENGTH 7
#endif

static const char enum_moastRobotType_string_list[ENUM_MOASTROBOTTYPE_LENGTH][MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH]= {
	"MOAST_AERIAL_ROBOT_TYPE", /* 0,2 */
	"MOAST_GROUND_VEHICLE_TYPE", /* 1,0 */
	"MOAST_INVALID_ROBOT_TYPE", /* 2,-1 */
	"MOAST_LEGGED_ROBOT_TYPE", /* 3,3 */
	"MOAST_NAUTIC_ROBOT_TYPE", /* 4,1 */
	"MOAST_UNKNOWN_ROBOT_TYPE", /* 5,4 */
	""};

static const int enum_moastRobotType_int_list[ENUM_MOASTROBOTTYPE_LENGTH]= {
	MOAST_AERIAL_ROBOT_TYPE, /* 0,2 */
	MOAST_GROUND_VEHICLE_TYPE, /* 1,0 */
	MOAST_INVALID_ROBOT_TYPE, /* 2,-1 */
	MOAST_LEGGED_ROBOT_TYPE, /* 3,3 */
	MOAST_NAUTIC_ROBOT_TYPE, /* 4,1 */
	MOAST_UNKNOWN_ROBOT_TYPE, /* 5,4 */
	};

const char *navDataExt_enum_moastRobotType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_AERIAL_ROBOT_TYPE: return("MOAST_AERIAL_ROBOT_TYPE"); /* 2 */
		case MOAST_GROUND_VEHICLE_TYPE: return("MOAST_GROUND_VEHICLE_TYPE"); /* 0 */
		case MOAST_INVALID_ROBOT_TYPE: return("MOAST_INVALID_ROBOT_TYPE"); /* -1 */
		case MOAST_LEGGED_ROBOT_TYPE: return("MOAST_LEGGED_ROBOT_TYPE"); /* 3 */
		case MOAST_NAUTIC_ROBOT_TYPE: return("MOAST_NAUTIC_ROBOT_TYPE"); /* 1 */
		case MOAST_UNKNOWN_ROBOT_TYPE: return("MOAST_UNKNOWN_ROBOT_TYPE"); /* 4 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastRobotType_info_struct={
	"moastRobotType",
	(const char **)enum_moastRobotType_string_list,
	enum_moastRobotType_int_list,
	MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH,
	ENUM_MOASTROBOTTYPE_LENGTH,
	(cms_symbol_lookup_function_t)navDataExt_enum_moastRobotType_symbol_lookup
	};

/*
Estimated_size	NavDataExt	400
Estimated_size	MAXIMUM	400
*/
/*
*	NML/CMS Format function : navDataExt_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed Nov 07 13:51:34 GMT-05:00 2007
*/
int navDataExt_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"navDataExt",
		(cms_symbol_lookup_function_t) navDataExt_symbol_lookup,
		(const char **)navDataExt_name_list,
		navDataExt_id_list,navDataExt_size_list,
		NAVDATAEXT_NAME_LIST_LENGTH,
		MAX_NAVDATAEXT_NAME_LENGTH);

	switch(type)
	{
	case NAV_DATA_EXT_TYPE:
		((NavDataExt *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *navDataExt_symbol_lookup(long type)
{
	switch(type)
	{
	case NAV_DATA_EXT_TYPE:
		return "NavDataExt";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for NavDataExt
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed Nov 07 13:51:34 GMT-05:00 2007
*/
void NavDataExt::update(CMS *cms)
{

	cms->beginClass("NavDataExt","NMLmsg");
	cms->update_with_name("time",time);
	cms->update_with_name("utmZone",utmZone);
	cms->update_with_name("utmLetter",utmLetter);
	cms->update_with_name("tranAbs",tranAbs);
	cms->update_with_name("rpyAbs",rpyAbs);
	cms->update_with_name("tranAbsRate",tranAbsRate);
	cms->update_with_name("rpyAbsRate",rpyAbsRate);
	cms->update_with_name("tranRel",tranRel);
	cms->update_with_name("rpyRel",rpyRel);
	cms->update_with_name("tranRelRate",tranRelRate);
	cms->update_with_name("rpyRelRate",rpyRelRate);
	cms->update_with_name("tranTrue",tranTrue);
	cms->update_with_name("rpyTrue",rpyTrue);
	cms->update_with_name("tranTrueRate",tranTrueRate);
	cms->update_with_name("rpyTrueRate",rpyTrueRate);
	cms->update_with_name("absToRel",absToRel);
	cms->update_with_name("speed",speed);
	cms->update_with_name("steeringCurvature",steeringCurvature);
	cms->update_with_name("steeringCrabAngle",steeringCrabAngle);
cms->update_with_name("isSLAMon",isSLAMon);
cms->update_with_name("LatitudeDegrees",LatitudeDegrees);
cms->update_with_name("LatitudeMinutes",LatitudeMinutes);
cms->update_with_name("LongitudeDegrees",LongitudeDegrees);
cms->update_with_name("LongitudeMinutes",LongitudeMinutes);
cms->update_with_name("Fix",Fix);
cms->update_with_name("Satellites",Satellites);

	cms->endClass("NavDataExt","NMLmsg");

}

