/*
*	New C++ File starts here.
*	This file should be named moastTypes.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "moastTypes.hh"
#include "moastNmlOffsets.hh"
#include "nmlMap.hh"

// Forward Function Prototypes


#ifndef MAX_NMLMAP_NAME_LENGTH
#define MAX_NMLMAP_NAME_LENGTH 7
#endif
#ifndef NMLMAP_NAME_LIST_LENGTH
#define NMLMAP_NAME_LIST_LENGTH 2
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
const char nmlMap_name_list[NMLMAP_NAME_LIST_LENGTH][MAX_NMLMAP_NAME_LENGTH]= {
	"MapMsg", /* 0,102 */
	""};
const NMLTYPE nmlMap_id_list[NMLMAP_NAME_LIST_LENGTH]= {
	MAP_MSG_TYPE, /* 0,102 */
	-1};
const size_t nmlMap_size_list[NMLMAP_NAME_LIST_LENGTH]= {
	sizeof(MapMsg),
	0};
const char *nmlMap_symbol_lookup(long type);


// Enumerated Type Constants

// anonymous_enum_______include_moastTypes_hh_288
#ifndef MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_STRING_LENGTH
#define MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_STRING_LENGTH 17
#endif
#ifndef ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_LENGTH
#define ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_LENGTH 3
#endif

static const char enum_anonymous_enum_______include_moastTypes_hh_288_string_list[ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_LENGTH][MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_STRING_LENGTH]= {
	"MOAST_ROTATE_CCW", /* 0,1 */
	"MOAST_ROTATE_CW", /* 1,0 */
	""};

static const int enum_anonymous_enum_______include_moastTypes_hh_288_int_list[ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_LENGTH]= {
	MOAST_ROTATE_CCW, /* 0,1 */
	MOAST_ROTATE_CW, /* 1,0 */
	};

const char *nmlMap_enum_anonymous_enum_______include_moastTypes_hh_288_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_ROTATE_CCW: return("MOAST_ROTATE_CCW"); /* 1 */
		case MOAST_ROTATE_CW: return("MOAST_ROTATE_CW"); /* 0 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_anonymous_enum_______include_moastTypes_hh_288_info_struct={
	"anonymous_enum_______include_moastTypes_hh_288",
	(const char **)enum_anonymous_enum_______include_moastTypes_hh_288_string_list,
	enum_anonymous_enum_______include_moastTypes_hh_288_int_list,
	MAX_ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_STRING_LENGTH,
	ENUM_ANONYMOUS_ENUM_______INCLUDE_MOASTTYPES_HH_288_LENGTH,
	(cms_symbol_lookup_function_t)nmlMap_enum_anonymous_enum_______include_moastTypes_hh_288_symbol_lookup
	};

// moastSteerType
#ifndef MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH 29
#endif
#ifndef ENUM_MOASTSTEERTYPE_LENGTH
#define ENUM_MOASTSTEERTYPE_LENGTH 9
#endif

static const char enum_moastSteerType_string_list[ENUM_MOASTSTEERTYPE_LENGTH][MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH]= {
	"MOAST_ACKERMAN_STEER_TYPE", /* 0,1 */
	"MOAST_FIXED_WING_STEER_TYPE", /* 1,5 */
	"MOAST_INVALID_STEER_TYPE", /* 2,-1 */
	"MOAST_OMNI_STEER_TYPE", /* 3,2 */
	"MOAST_ROTARY_WING_STEER_TYPE", /* 4,4 */
	"MOAST_SKID_STEER_TYPE", /* 5,0 */
	"MOAST_SUBMARINE_STEER_TYPE", /* 6,3 */
	"MOAST_UNKNOWN_STEER_TYPE", /* 7,6 */
	""};

static const int enum_moastSteerType_int_list[ENUM_MOASTSTEERTYPE_LENGTH]= {
	MOAST_ACKERMAN_STEER_TYPE, /* 0,1 */
	MOAST_FIXED_WING_STEER_TYPE, /* 1,5 */
	MOAST_INVALID_STEER_TYPE, /* 2,-1 */
	MOAST_OMNI_STEER_TYPE, /* 3,2 */
	MOAST_ROTARY_WING_STEER_TYPE, /* 4,4 */
	MOAST_SKID_STEER_TYPE, /* 5,0 */
	MOAST_SUBMARINE_STEER_TYPE, /* 6,3 */
	MOAST_UNKNOWN_STEER_TYPE, /* 7,6 */
	};

const char *nmlMap_enum_moastSteerType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_ACKERMAN_STEER_TYPE: return("MOAST_ACKERMAN_STEER_TYPE"); /* 1 */
		case MOAST_FIXED_WING_STEER_TYPE: return("MOAST_FIXED_WING_STEER_TYPE"); /* 5 */
		case MOAST_INVALID_STEER_TYPE: return("MOAST_INVALID_STEER_TYPE"); /* -1 */
		case MOAST_OMNI_STEER_TYPE: return("MOAST_OMNI_STEER_TYPE"); /* 2 */
		case MOAST_ROTARY_WING_STEER_TYPE: return("MOAST_ROTARY_WING_STEER_TYPE"); /* 4 */
		case MOAST_SKID_STEER_TYPE: return("MOAST_SKID_STEER_TYPE"); /* 0 */
		case MOAST_SUBMARINE_STEER_TYPE: return("MOAST_SUBMARINE_STEER_TYPE"); /* 3 */
		case MOAST_UNKNOWN_STEER_TYPE: return("MOAST_UNKNOWN_STEER_TYPE"); /* 6 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastSteerType_info_struct={
	"moastSteerType",
	(const char **)enum_moastSteerType_string_list,
	enum_moastSteerType_int_list,
	MAX_ENUM_MOASTSTEERTYPE_STRING_LENGTH,
	ENUM_MOASTSTEERTYPE_LENGTH,
	(cms_symbol_lookup_function_t)nmlMap_enum_moastSteerType_symbol_lookup
	};

// moastFlipperType
#ifndef MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH 22
#endif
#ifndef ENUM_MOASTFLIPPERTYPE_LENGTH
#define ENUM_MOASTFLIPPERTYPE_LENGTH 5
#endif

static const char enum_moastFlipperType_string_list[ENUM_MOASTFLIPPERTYPE_LENGTH][MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH]= {
	"MOAST_FL_FLIPPER_TYPE", /* 0,1 */
	"MOAST_FR_FLIPPER_TYPE", /* 1,0 */
	"MOAST_RL_FLIPPER_TYPE", /* 2,3 */
	"MOAST_RR_FLIPPER_TYPE", /* 3,2 */
	""};

static const int enum_moastFlipperType_int_list[ENUM_MOASTFLIPPERTYPE_LENGTH]= {
	MOAST_FL_FLIPPER_TYPE, /* 0,1 */
	MOAST_FR_FLIPPER_TYPE, /* 1,0 */
	MOAST_RL_FLIPPER_TYPE, /* 2,3 */
	MOAST_RR_FLIPPER_TYPE, /* 3,2 */
	};

const char *nmlMap_enum_moastFlipperType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_FL_FLIPPER_TYPE: return("MOAST_FL_FLIPPER_TYPE"); /* 1 */
		case MOAST_FR_FLIPPER_TYPE: return("MOAST_FR_FLIPPER_TYPE"); /* 0 */
		case MOAST_RL_FLIPPER_TYPE: return("MOAST_RL_FLIPPER_TYPE"); /* 3 */
		case MOAST_RR_FLIPPER_TYPE: return("MOAST_RR_FLIPPER_TYPE"); /* 2 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastFlipperType_info_struct={
	"moastFlipperType",
	(const char **)enum_moastFlipperType_string_list,
	enum_moastFlipperType_int_list,
	MAX_ENUM_MOASTFLIPPERTYPE_STRING_LENGTH,
	ENUM_MOASTFLIPPERTYPE_LENGTH,
	(cms_symbol_lookup_function_t)nmlMap_enum_moastFlipperType_symbol_lookup
	};

// moastRobotType
#ifndef MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH
#define MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH 26
#endif
#ifndef ENUM_MOASTROBOTTYPE_LENGTH
#define ENUM_MOASTROBOTTYPE_LENGTH 7
#endif

static const char enum_moastRobotType_string_list[ENUM_MOASTROBOTTYPE_LENGTH][MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH]= {
	"MOAST_AERIAL_ROBOT_TYPE", /* 0,2 */
	"MOAST_GROUND_VEHICLE_TYPE", /* 1,0 */
	"MOAST_INVALID_ROBOT_TYPE", /* 2,-1 */
	"MOAST_LEGGED_ROBOT_TYPE", /* 3,3 */
	"MOAST_NAUTIC_ROBOT_TYPE", /* 4,1 */
	"MOAST_UNKNOWN_ROBOT_TYPE", /* 5,4 */
	""};

static const int enum_moastRobotType_int_list[ENUM_MOASTROBOTTYPE_LENGTH]= {
	MOAST_AERIAL_ROBOT_TYPE, /* 0,2 */
	MOAST_GROUND_VEHICLE_TYPE, /* 1,0 */
	MOAST_INVALID_ROBOT_TYPE, /* 2,-1 */
	MOAST_LEGGED_ROBOT_TYPE, /* 3,3 */
	MOAST_NAUTIC_ROBOT_TYPE, /* 4,1 */
	MOAST_UNKNOWN_ROBOT_TYPE, /* 5,4 */
	};

const char *nmlMap_enum_moastRobotType_symbol_lookup(long v)
{
	switch(v)
	{
		case MOAST_AERIAL_ROBOT_TYPE: return("MOAST_AERIAL_ROBOT_TYPE"); /* 2 */
		case MOAST_GROUND_VEHICLE_TYPE: return("MOAST_GROUND_VEHICLE_TYPE"); /* 0 */
		case MOAST_INVALID_ROBOT_TYPE: return("MOAST_INVALID_ROBOT_TYPE"); /* -1 */
		case MOAST_LEGGED_ROBOT_TYPE: return("MOAST_LEGGED_ROBOT_TYPE"); /* 3 */
		case MOAST_NAUTIC_ROBOT_TYPE: return("MOAST_NAUTIC_ROBOT_TYPE"); /* 1 */
		case MOAST_UNKNOWN_ROBOT_TYPE: return("MOAST_UNKNOWN_ROBOT_TYPE"); /* 4 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_moastRobotType_info_struct={
	"moastRobotType",
	(const char **)enum_moastRobotType_string_list,
	enum_moastRobotType_int_list,
	MAX_ENUM_MOASTROBOTTYPE_STRING_LENGTH,
	ENUM_MOASTROBOTTYPE_LENGTH,
	(cms_symbol_lookup_function_t)nmlMap_enum_moastRobotType_symbol_lookup
	};

// C8Color
#ifndef MAX_ENUM_C8COLOR_STRING_LENGTH
#define MAX_ENUM_C8COLOR_STRING_LENGTH 10
#endif
#ifndef ENUM_C8COLOR_LENGTH
#define ENUM_C8COLOR_LENGTH 8
#endif

static const char enum_C8Color_string_list[ENUM_C8COLOR_LENGTH][MAX_ENUM_C8COLOR_STRING_LENGTH]= {
	"C8Black", /* 0,1 */
	"C8Blue", /* 1,2 */
	"C8Cyan", /* 2,8 */
	"C8Green", /* 3,4 */
	"C8Magenta", /* 4,32 */
	"C8Red", /* 5,16 */
	"C8White", /* 6,64 */
	""};

static const int enum_C8Color_int_list[ENUM_C8COLOR_LENGTH]= {
	C8Black, /* 0,1 */
	C8Blue, /* 1,2 */
	C8Cyan, /* 2,8 */
	C8Green, /* 3,4 */
	C8Magenta, /* 4,32 */
	C8Red, /* 5,16 */
	C8White, /* 6,64 */
	};

const char *nmlMap_enum_C8Color_symbol_lookup(long v)
{
	switch(v)
	{
		case C8Black: return("C8Black"); /* 1 */
		case C8Blue: return("C8Blue"); /* 2 */
		case C8Cyan: return("C8Cyan"); /* 8 */
		case C8Green: return("C8Green"); /* 4 */
		case C8Magenta: return("C8Magenta"); /* 32 */
		case C8Red: return("C8Red"); /* 16 */
		case C8White: return("C8White"); /* 64 */
		default:break;
	}
	return("!!UNDEFINED_SYMBOL!!");
}

static const struct cms_enum_info enum_C8Color_info_struct={
	"C8Color",
	(const char **)enum_C8Color_string_list,
	enum_C8Color_int_list,
	MAX_ENUM_C8COLOR_STRING_LENGTH,
	ENUM_C8COLOR_LENGTH,
	(cms_symbol_lookup_function_t)nmlMap_enum_C8Color_symbol_lookup
	};

/*
Estimated_size	MapMsg	40072
Estimated_size	MAXIMUM	40072
*/
/*
*	NML/CMS Format function : nmlMap_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed Nov 07 13:51:38 GMT-05:00 2007
*/
int nmlMap_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"nmlMap",
		(cms_symbol_lookup_function_t) nmlMap_symbol_lookup,
		(const char **)nmlMap_name_list,
		nmlMap_id_list,nmlMap_size_list,
		NMLMAP_NAME_LIST_LENGTH,
		MAX_NMLMAP_NAME_LENGTH);

	switch(type)
	{
	case MAP_MSG_TYPE:
		((MapMsg *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *nmlMap_symbol_lookup(long type)
{
	switch(type)
	{
	case MAP_MSG_TYPE:
		return "MapMsg";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for MapMsg
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed Nov 07 13:51:38 GMT-05:00 2007
*/
void MapMsg::update(CMS *cms)
{

	cms->beginClass("MapMsg","NMLmsg");
	cms->update_with_name("nRows",nRows);
	cms->update_with_name("nCols",nCols);
	cms->update_with_name("mapX",mapX);
	cms->update_with_name("mapY",mapY);
	cms->update_with_name("mapRealWidth",mapRealWidth);
	cms->update_dla_length_with_name("map_length",map_length);
	cms->update_dla_with_name("map",map,map_length,40000);

	cms->endClass("MapMsg","NMLmsg");

}

