#!/bin/sh

# get RCS directory and add to shared library load path
if test "x${RCSLIB_DIR}" = "x" ; then
    RCSLIB_DIR=`grep RCSLIB_DIR ../Makefile | awk '{print $3}'`
fi

if test x$RCSLIB_DIR != x ; then
    LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$RCSLIB_DIR/lib
    export LD_LIBRARY_PATH
fi

map=`ls -1 last_log_dir/*_SensorDataArray_*_map.txt | head -n 1`;

${RCSLIB_DIR}/bin/nml_packed_file_to_csv ${map} last_log_dir/servoSPNav1_1/servoSPNav1_*.SensorDataArray  | awk -F, '{print $3,$4}'  | awk '{if ( $1 =="arrayElem[0].dataTuple[0]" ) x = $2; else if ( $1 =="arrayElem[0].dataTuple[1]" ) printf("%f,%f\n",x,$2); }' >plot.xy

java -jar ${RCSLIB_DIR}/bin/plotter_NB.jar plot.xy
