#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

if {$argc < 1} {
  puts stderr "syntax: ppm.tcl <image file>"
  exit
}

set img [lindex $argv 0]

if {! [file exists $img]} {
  puts stderr "can't find file $img"
  exit
}

if {[catch {image create photo image1 -file $img}]} {
  puts stderr "bad image file $img"
  exit
}

label .label -image image1
pack .label

while {1} {
    update idletasks
    image delete image1
    catch {image create photo image1 -file $img}
    after 100
}
