/*
  DISCLAIMER:
  This software was produced by the National Institute of Standards
  and Technology (NIST), an agency of the U.S. government, and by statute is
  not subject to copyright in the United States.  Recipients of this software
  assume all responsibility associated with its operation, modification,
  maintenance, and subsequent redistribution.

  See NIST Administration Manual 4.09.07 b and Appendix I. 
*/

/*!
  \file skelCommon.hh

  \brief Starting numbers for MOAST NMLtype declarations

  \code CVS Status:
  $Author: root $
  $Revision: 1.1.1.1 $
  $Date: 2005/10/12 20:50:32 $
  \endcode

  \author Fred Proctor
*/
#ifndef SKEL_COMMON_HH
#define SKEL_COMMON_HH

#define SKEL_CMD_BASE 100
#define SKEL_STAT_BASE 200
#define SKEL_CFG_BASE 300
#define SKEL_SET_BASE 400

#endif // SKEL_COMMON_HH
/*
  Modification history:

  $Log: skelCommon.hh,v $
  Revision 1.1.1.1  2005/10/12 20:50:32  root
  initial import

  Revision 1.1  2005/10/11 18:45:03  stephen
  Initial addition of skeleton rcs controller.

*/
