/*
  DISCLAIMER:
  This software was produced by the National Institute of Standards
  and Technology (NIST), an agency of the U.S. government, and by statute is
  not subject to copyright in the United States.  Recipients of this software
  assume all responsibility associated with its operation, modification,
  maintenance, and subsequent redistribution.

  See NIST Administration Manual 4.09.07 b and Appendix I. 
*/

/*!
  \file amMobMain.hh

  \brief non-NML declarations for autonomous mobility (AM) level mobility

  Synopsis:
  #include <rcs.hh>
  #include <posemath.h>
  #include "moastNmlOffsets.hh"
  
  \code CVS Status:
  $Author: tomrkramer $
  $Revision: 1.2 $
  $Date: 2006/09/25 21:54:45 $
  \endcode

  \author Tom Kramer
*/

#ifndef AM_MOB_MAIN_HH
#define AM_MOB_MAIN_HH

/***********************************************************************/

/* Nothing needed */

/***********************************************************************/

#endif // AM_MOB_MAIN_HH

/*
  Modification history:

  $Log: amMobMain.hh,v $
  Revision 1.2  2006/09/25 21:54:45  tomrkramer
  Removed code for lineHop class, which is no longer used.

  Revision 1.1  2006/01/17 22:20:16  tomrkramer
  initial checkin

  
*/
