/*****************************************************************************
  DISCLAIMER:
  This software was produced by the National Institute of Standards
  and Technology (NIST), an agency of the U.S. government, and by statute is
  not subject to copyright in the United States.  Recipients of this software
  assume all responsibility associated with its operation, modification,
  maintenance, and subsequent redistribution.

  See NIST Administration Manual 4.09.07 b and Appendix I. 
*****************************************************************************/

/*!
  \file moastscript.hh
  \brief Declarations for scripting interface to Moast NML commands, status.

  \code CVS Status:
  $Author: root $
  $Revision: 1.1.1.1 $
  $Date: 2005/10/12 20:50:32 $
  \endcode

  \author Fred Proctor
*/

#ifndef MOASTSCRIPT_HH
#define MOASTSCRIPT_HH

extern int nmlConnect(char * nml_file_given);

extern int nmlDisconnect(void);

extern int nmlSetChannel(int channel);

extern int servoMobJACmdInit(void);

#endif
