/*
*	New C++ Header  File starts here.
*	This file should be named ../../include/moastTypes_n_codegen_protos.hh
*/

#ifndef ______include_moastTypes_n_codegen_protos_hh_included
#define ______include_moastTypes_n_codegen_protos_hh_included

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "moastTypes.hh"

// Forward Function Prototypes
extern void nmlupdate(CMS *cms, constrainedFloat *x);
extern void initialize_constrainedFloat(constrainedFloat *x);
extern void nmlupdate(CMS *cms, constrainedDouble *x);
extern void initialize_constrainedDouble(constrainedDouble *x);
extern void nmlupdate(CMS *cms, constrainedInt *x);
extern void initialize_constrainedInt(constrainedInt *x);
extern void nmlupdate(CMS *cms, ArcSegment *x);
extern void initialize_ArcSegment(ArcSegment *x);
extern void nmlupdate(CMS *cms, SensorPoint *x);
extern void nmlupdate(CMS *cms, Location2D *x);
extern void nmlupdate(CMS *cms, Waypoint *x);
extern void initialize_Waypoint(Waypoint *x);


#ifndef MAX_MOASTTYPES_NAME_LENGTH
#define MAX_MOASTTYPES_NAME_LENGTH 1
#endif
#ifndef MOASTTYPES_NAME_LIST_LENGTH
#define MOASTTYPES_NAME_LIST_LENGTH 1
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
extern const NMLTYPE moastTypes_id_list[MOASTTYPES_NAME_LIST_LENGTH];
extern const size_t moastTypes_size_list[MOASTTYPES_NAME_LIST_LENGTH];

// Enumerated Type Constants

extern int moastTypes_format(NMLTYPE type, void *buffer, CMS *cms);

#endif
	/* # endif ______include_moastTypes_n_codegen_protos_hh_included */ 

