/*
*	New C++ Header  File starts here.
*	This file should be named ../../include/primMobJA_n_codegen_protos.hh
*/

#ifndef ______include_primMobJA_n_codegen_protos_hh_included
#define ______include_primMobJA_n_codegen_protos_hh_included

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "primMobJA.hh"
#include "moastTypes.hh"
#include "moastNmlOffsets.hh"

// Forward Function Prototypes
extern void nmlupdate(CMS *cms, ArcSegment *x);
extern void nmlupdate(CMS *cms, Waypoint *x);


#ifndef MAX_PRIMMOBJA_NAME_LENGTH
#define MAX_PRIMMOBJA_NAME_LENGTH 27
#endif
#ifndef PRIMMOBJA_NAME_LIST_LENGTH
#define PRIMMOBJA_NAME_LIST_LENGTH 18
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
extern const NMLTYPE primMobJA_id_list[PRIMMOBJA_NAME_LIST_LENGTH];
extern const size_t primMobJA_size_list[PRIMMOBJA_NAME_LIST_LENGTH];

// Enumerated Type Constants

extern int primMobJA_format(NMLTYPE type, void *buffer, CMS *cms);

#endif
	/* # endif ______include_primMobJA_n_codegen_protos_hh_included */ 

