/*
*	New C++ Header  File starts here.
*	This file should be named ../../include/servoMisJA_n_codegen_protos.hh
*/

#ifndef ______include_servoMisJA_n_codegen_protos_hh_included
#define ______include_servoMisJA_n_codegen_protos_hh_included

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "servoMisJA.hh"
#include "moastNmlOffsets.hh"
#include "moastTypes.hh"

// Forward Function Prototypes
extern void nmlupdate(CMS *cms, ServoMisJALinkCmd *x);
extern void nmlupdate(CMS *cms, ServoMisJALinkSet *x);
extern void initialize_ServoMisJALinkSet(ServoMisJALinkSet *x);
extern void initialize_ServoMisJALinkCmd(ServoMisJALinkCmd *x);
extern void nmlupdate(CMS *cms, ServoMisJALinkStat *x);
extern void initialize_ServoMisJALinkStat(ServoMisJALinkStat *x);


#ifndef MAX_SERVOMISJA_NAME_LENGTH
#define MAX_SERVOMISJA_NAME_LENGTH 23
#endif
#ifndef SERVOMISJA_NAME_LIST_LENGTH
#define SERVOMISJA_NAME_LIST_LENGTH 10
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
extern const NMLTYPE servoMisJA_id_list[SERVOMISJA_NAME_LIST_LENGTH];
extern const size_t servoMisJA_size_list[SERVOMISJA_NAME_LIST_LENGTH];

// Enumerated Type Constants

extern int servoMisJA_format(NMLTYPE type, void *buffer, CMS *cms);

#endif
	/* # endif ______include_servoMisJA_n_codegen_protos_hh_included */ 

