/*
*	New C++ Header  File starts here.
*	This file should be named ../../include/servoSP_n_codegen_protos.hh
*/

#ifndef ______include_servoSP_n_codegen_protos_hh_included
#define ______include_servoSP_n_codegen_protos_hh_included

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "servoSP.hh"
#include "moastTypes.hh"
#include "moastNmlOffsets.hh"

// Forward Function Prototypes
extern void nmlupdate(CMS *cms, SensorSetElem *x);
extern void initialize_SensorSetElem(SensorSetElem *x);


#ifndef MAX_SERVOSP_NAME_LENGTH
#define MAX_SERVOSP_NAME_LENGTH 20
#endif
#ifndef SERVOSP_NAME_LIST_LENGTH
#define SERVOSP_NAME_LIST_LENGTH 10
#endif


/* This list must be in alphabetical order and the three lists must correspond. */
extern const NMLTYPE servoSP_id_list[SERVOSP_NAME_LIST_LENGTH];
extern const size_t servoSP_size_list[SERVOSP_NAME_LIST_LENGTH];

// Enumerated Type Constants

extern int servoSP_format(NMLTYPE type, void *buffer, CMS *cms);

#endif
	/* # endif ______include_servoSP_n_codegen_protos_hh_included */ 

