/*
*	New C++ File starts here.
*	This file should be named amMobJA.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "amMobJA.hh"
#include "moastTypes.hh"
#include "moastNmlOffsets.hh"

// Include externally supplied prototypes
#include "../../include/amMobJA_n_codegen_protos.hh"



#ifndef AMMOBJA_NAME_LIST_LENGTH
#define AMMOBJA_NAME_LIST_LENGTH 19
#endif

const NMLTYPE amMobJA_id_list[AMMOBJA_NAME_LIST_LENGTH]= {
	AM_MOB_JA_CFG_CELL_RESOLUTION_TYPE, /* 0,11201 */
	AM_MOB_JA_CFG_CYCLE_TIME_TYPE, /* 1,11202 */
	AM_MOB_JA_CFG_DEBUG_TYPE, /* 2,11203 */
	AM_MOB_JA_CFG_DUMP_WM_TYPE, /* 3,11204 */
	AM_MOB_JA_CFG_NOP_TYPE, /* 4,11205 */
	AM_MOB_JA_CFG_PLAN_HORIZON_TYPE, /* 5,11206 */
	AM_MOB_JA_CFG_VEHICLE_MIN_TURN_RAD_TYPE, /* 6,11207 */
	AM_MOB_JA_CFG_VEHICLE_WIDTH_TYPE, /* 7,11208 */
	AM_MOB_JA_CMD_ABORT_TYPE, /* 8,11002 */
	AM_MOB_JA_CMD_HALT_TYPE, /* 9,11003 */
	AM_MOB_JA_CMD_INIT_TYPE, /* 10,11001 */
	AM_MOB_JA_CMD_MOVE_WAYPOINT_TYPE, /* 11,11005 */
	AM_MOB_JA_CMD_NOP_TYPE, /* 12,11007 */
	AM_MOB_JA_CMD_PREPARE_MOVE_TYPE, /* 13,11006 */
	AM_MOB_JA_CMD_SHUTDOWN_TYPE, /* 14,11004 */
	AM_MOB_JA_CMD_SPIN_TYPE, /* 15,11008 */
	AM_MOB_JA_SET_TYPE, /* 16,11301 */
	AM_MOB_JA_STAT_TYPE, /* 17,11101 */
	-1};
const size_t amMobJA_size_list[AMMOBJA_NAME_LIST_LENGTH]= {
	sizeof(AmMobJACfgCellResolution),
	sizeof(AmMobJACfgCycleTime),
	sizeof(AmMobJACfgDebug),
	sizeof(AmMobJACfgDumpWM),
	sizeof(AmMobJACfgNop),
	sizeof(AmMobJACfgPlanHorizon),
	sizeof(AmMobJACfgVehicleMinTurnRad),
	sizeof(AmMobJACfgVehicleWidth),
	sizeof(AmMobJACmdAbort),
	sizeof(AmMobJACmdHalt),
	sizeof(AmMobJACmdInit),
	sizeof(AmMobJACmdMoveWaypoint),
	sizeof(AmMobJACmdNop),
	sizeof(AmMobJACmdPrepareMove),
	sizeof(AmMobJACmdShutdown),
	sizeof(AmMobJACmdSpin),
	sizeof(AmMobJASet),
	sizeof(AmMobJAStat),
	0};


// Enumerated Type Constants

/*
Estimated_size	AmMobJACfgCellResolution	32
Estimated_size	AmMobJACfgCycleTime	32
Estimated_size	AmMobJACfgDebug	32
Estimated_size	AmMobJACfgDumpWM	25
Estimated_size	AmMobJACfgNop	24
Estimated_size	AmMobJACfgPlanHorizon	32
Estimated_size	AmMobJACfgVehicleMinTurnRad	32
Estimated_size	AmMobJACfgVehicleWidth	32
Estimated_size	AmMobJACmdAbort	24
Estimated_size	AmMobJACmdHalt	24
Estimated_size	AmMobJACmdInit	24
Estimated_size	AmMobJACmdMoveWaypoint	4164
Estimated_size	AmMobJACmdNop	24
Estimated_size	AmMobJACmdPrepareMove	40
Estimated_size	AmMobJACmdShutdown	24
Estimated_size	AmMobJACmdSpin	48
Estimated_size	AmMobJASet	240
Estimated_size	AmMobJAStat	5120
Estimated_size	MAXIMUM	5120
*/
/*
*	NML/CMS Format function : amMobJA_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
int amMobJA_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"amMobJA",
		(cms_symbol_lookup_function_t) 0,
		(const char **) 0,
		amMobJA_id_list,amMobJA_size_list,
		AMMOBJA_NAME_LIST_LENGTH,
		0);

	switch(type)
	{
	case AM_MOB_JA_CFG_CELL_RESOLUTION_TYPE:
		((AmMobJACfgCellResolution *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CFG_CYCLE_TIME_TYPE:
		((AmMobJACfgCycleTime *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CFG_DEBUG_TYPE:
		((AmMobJACfgDebug *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CFG_DUMP_WM_TYPE:
		((AmMobJACfgDumpWM *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CFG_NOP_TYPE:
		((AmMobJACfgNop *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CFG_PLAN_HORIZON_TYPE:
		((AmMobJACfgPlanHorizon *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CFG_VEHICLE_MIN_TURN_RAD_TYPE:
		((AmMobJACfgVehicleMinTurnRad *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CFG_VEHICLE_WIDTH_TYPE:
		((AmMobJACfgVehicleWidth *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_ABORT_TYPE:
		((AmMobJACmdAbort *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_HALT_TYPE:
		((AmMobJACmdHalt *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_INIT_TYPE:
		((AmMobJACmdInit *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_MOVE_WAYPOINT_TYPE:
		((AmMobJACmdMoveWaypoint *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_NOP_TYPE:
		((AmMobJACmdNop *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_PREPARE_MOVE_TYPE:
		((AmMobJACmdPrepareMove *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_SHUTDOWN_TYPE:
		((AmMobJACmdShutdown *) buffer)->update(cms);
		break;
	case AM_MOB_JA_CMD_SPIN_TYPE:
		((AmMobJACmdSpin *) buffer)->update(cms);
		break;
	case AM_MOB_JA_SET_TYPE:
		((AmMobJASet *) buffer)->update(cms);
		break;
	case AM_MOB_JA_STAT_TYPE:
		((AmMobJAStat *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}

/*
*	NML/CMS Update function for AmMobJACfgCellResolution
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACfgCellResolution::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgCellResolution","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cellResolution",cellResolution);

	cms->endClass("AmMobJACfgCellResolution","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACfgCycleTime
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACfgCycleTime::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgCycleTime","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);

	cms->endClass("AmMobJACfgCycleTime","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACfgDebug
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACfgDebug::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgDebug","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("debug",debug);

	cms->endClass("AmMobJACfgDebug","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACfgDumpWM
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACfgDumpWM::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgDumpWM","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("turnOn",turnOn);

	cms->endClass("AmMobJACfgDumpWM","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACfgNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACfgNop::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMobJACfgNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACfgPlanHorizon
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACfgPlanHorizon::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgPlanHorizon","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("planHorizon",planHorizon);

	cms->endClass("AmMobJACfgPlanHorizon","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACfgVehicleMinTurnRad
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACfgVehicleMinTurnRad::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgVehicleMinTurnRad","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("vehicleMinTurnRad",vehicleMinTurnRad);

	cms->endClass("AmMobJACfgVehicleMinTurnRad","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACfgVehicleWidth
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACfgVehicleWidth::update(CMS *cms)
{

	cms->beginClass("AmMobJACfgVehicleWidth","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("vehicleWidth",vehicleWidth);

	cms->endClass("AmMobJACfgVehicleWidth","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdAbort
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACmdAbort::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdAbort","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMobJACmdAbort","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdHalt
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACmdHalt::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdHalt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMobJACmdHalt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdInit
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACmdInit::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdInit","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMobJACmdInit","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdMoveWaypoint
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACmdMoveWaypoint::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdMoveWaypoint","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("computeHorizonCosts",computeHorizonCosts);
	cms->update_with_name("neighborhood",neighborhood);
	cms->update_with_name("speed",speed);
	cms->update_dla_length_with_name("waypoint_length",waypoint_length);
	cms->beginStructDynamicArray("waypoint",waypoint_length,100);
	for(int i_waypoint = 0;i_waypoint < waypoint_length ;i_waypoint++)
	{
		cms->beginStructArrayElem("waypoint",i_waypoint);
		nmlupdate(cms,&(waypoint[i_waypoint]));
		cms->endStructArrayElem("waypoint",i_waypoint);
	}
	cms->endStructDynamicArray("waypoint",waypoint_length,100);

	cms->endClass("AmMobJACmdMoveWaypoint","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACmdNop::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMobJACmdNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdPrepareMove
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACmdPrepareMove::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdPrepareMove","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("neighborhood",neighborhood);
	cms->update_with_name("speed",speed);

	cms->endClass("AmMobJACmdPrepareMove","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdShutdown
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACmdShutdown::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdShutdown","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("AmMobJACmdShutdown","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJACmdSpin
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJACmdSpin::update(CMS *cms)
{

	cms->beginClass("AmMobJACmdSpin","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("direction",direction);
	cms->update_with_name("absAngle",absAngle);
	cms->update_with_name("tolerance",tolerance);

	cms->endClass("AmMobJACmdSpin","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for AmMobJASet
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJASet::update(CMS *cms)
{

	cms->beginClass("AmMobJASet","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("cellResolution",cellResolution);
	cms->update_with_name("controlPoint",controlPoint);
	cms->update_with_name("cycleTime",cycleTime);
	cms->update_with_name("debug",debug);
	cms->update_with_name("dumpWM",dumpWM);
	cms->update_with_name("planHorizon",planHorizon);
	cms->update_with_name("vehicleMinTurnRad",vehicleMinTurnRad);
	cms->update_with_name("vehicleWidth",vehicleWidth);

	cms->endClass("AmMobJASet","RCS_STAT_MSG");

}


/*
*	NML/CMS Update function for AmMobJAStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:54 PDT 2008
*/
void AmMobJAStat::update(CMS *cms)
{

	cms->beginClass("AmMobJAStat","RCS_STAT_MSG_V2");

	cms->beginBaseClass("RCS_STAT_MSG_V2");
	RCS_STAT_MSG_V2::update(cms);
	cms->endBaseClass("RCS_STAT_MSG_V2");

	cms->update_with_name("amMobJAError",amMobJAError);
	cms->update_dla_length_with_name("seed_length",seed_length);
	cms->update_dla_with_name("seed",seed,seed_length,200);

	cms->endClass("AmMobJAStat","RCS_STAT_MSG_V2");

}

