#!/bin/sh

cd `dirname $0`

# get RCSLIB_DIR
. ../../rcslib_dir

CODEGEN=$RCSLIB_DIR/bin/CodeGenCmdLine.jar

for file in $* ; do
# this step takes e.g. moastError.hh, and builds moast/moastError.java,
# where the directory name is the package name
    java -jar $CODEGEN java_package_name=moast generate_for_java=true $file
done

exit 0
