/*
*	New C++ File starts here.
*	This file should be named primMobJA.cc
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "primMobJA.hh"
#include "moastTypes.hh"
#include "moastNmlOffsets.hh"

// Include externally supplied prototypes
#include "../../include/primMobJA_n_codegen_protos.hh"



#ifndef PRIMMOBJA_NAME_LIST_LENGTH
#define PRIMMOBJA_NAME_LIST_LENGTH 18
#endif

const NMLTYPE primMobJA_id_list[PRIMMOBJA_NAME_LIST_LENGTH]= {
	PRIM_MOB_JA_CFG_CYCLE_TIME_TYPE, /* 0,8202 */
	PRIM_MOB_JA_CFG_DEBUG_TYPE, /* 1,8204 */
	PRIM_MOB_JA_CFG_MOVE_TYPE, /* 2,8203 */
	PRIM_MOB_JA_CFG_NOP_TYPE, /* 3,8201 */
	PRIM_MOB_JA_CMD_ABORT_TYPE, /* 4,8003 */
	PRIM_MOB_JA_CMD_DOCK_TYPE, /* 5,8011 */
	PRIM_MOB_JA_CMD_HALT_TYPE, /* 6,8004 */
	PRIM_MOB_JA_CMD_INIT_TYPE, /* 7,8002 */
	PRIM_MOB_JA_CMD_MOVE_ARC_SEGMENT_TYPE, /* 8,8006 */
	PRIM_MOB_JA_CMD_MOVE_WAYPOINT_TYPE, /* 9,8007 */
	PRIM_MOB_JA_CMD_NOP_TYPE, /* 10,8001 */
	PRIM_MOB_JA_CMD_ROTATE_TYPE, /* 11,8008 */
	PRIM_MOB_JA_CMD_SHUTDOWN_TYPE, /* 12,8005 */
	PRIM_MOB_JA_CMD_STOP_TYPE, /* 13,8010 */
	PRIM_MOB_JA_CMD_VEL_TYPE, /* 14,8009 */
	PRIM_MOB_JA_SET_TYPE, /* 15,8301 */
	PRIM_MOB_JA_STAT_TYPE, /* 16,8101 */
	-1};
const size_t primMobJA_size_list[PRIMMOBJA_NAME_LIST_LENGTH]= {
	sizeof(PrimMobJACfgCycleTime),
	sizeof(PrimMobJACfgDebug),
	sizeof(PrimMobJACfgMove),
	sizeof(PrimMobJACfgNop),
	sizeof(PrimMobJACmdAbort),
	sizeof(PrimMobJACmdDock),
	sizeof(PrimMobJACmdHalt),
	sizeof(PrimMobJACmdInit),
	sizeof(PrimMobJACmdMoveArcSegment),
	sizeof(PrimMobJACmdMoveWaypoint),
	sizeof(PrimMobJACmdNop),
	sizeof(PrimMobJACmdRotate),
	sizeof(PrimMobJACmdShutdown),
	sizeof(PrimMobJACmdStop),
	sizeof(PrimMobJACmdVel),
	sizeof(PrimMobJASet),
	sizeof(PrimMobJAStat),
	0};


// Enumerated Type Constants

/*
Estimated_size	PrimMobJACfgCycleTime	32
Estimated_size	PrimMobJACfgDebug	32
Estimated_size	PrimMobJACfgMove	72
Estimated_size	PrimMobJACfgNop	24
Estimated_size	PrimMobJACmdAbort	24
Estimated_size	PrimMobJACmdDock	144
Estimated_size	PrimMobJACmdHalt	24
Estimated_size	PrimMobJACmdInit	24
Estimated_size	PrimMobJACmdMoveArcSegment	10440
Estimated_size	PrimMobJACmdMoveWaypoint	4140
Estimated_size	PrimMobJACmdNop	24
Estimated_size	PrimMobJACmdRotate	48
Estimated_size	PrimMobJACmdShutdown	24
Estimated_size	PrimMobJACmdStop	24
Estimated_size	PrimMobJACmdVel	40
Estimated_size	PrimMobJASet	248
Estimated_size	PrimMobJAStat	320
Estimated_size	MAXIMUM	10440
*/
/*
*	NML/CMS Format function : primMobJA_format
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
int primMobJA_format(NMLTYPE type, void *buffer, CMS *cms)
{

	type = cms->check_type_info(type,buffer,"primMobJA",
		(cms_symbol_lookup_function_t) 0,
		(const char **) 0,
		primMobJA_id_list,primMobJA_size_list,
		PRIMMOBJA_NAME_LIST_LENGTH,
		0);

	switch(type)
	{
	case PRIM_MOB_JA_CFG_CYCLE_TIME_TYPE:
		((PrimMobJACfgCycleTime *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CFG_DEBUG_TYPE:
		((PrimMobJACfgDebug *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CFG_MOVE_TYPE:
		((PrimMobJACfgMove *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CFG_NOP_TYPE:
		((PrimMobJACfgNop *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_ABORT_TYPE:
		((PrimMobJACmdAbort *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_DOCK_TYPE:
		((PrimMobJACmdDock *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_HALT_TYPE:
		((PrimMobJACmdHalt *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_INIT_TYPE:
		((PrimMobJACmdInit *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_MOVE_ARC_SEGMENT_TYPE:
		((PrimMobJACmdMoveArcSegment *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_MOVE_WAYPOINT_TYPE:
		((PrimMobJACmdMoveWaypoint *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_NOP_TYPE:
		((PrimMobJACmdNop *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_ROTATE_TYPE:
		((PrimMobJACmdRotate *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_SHUTDOWN_TYPE:
		((PrimMobJACmdShutdown *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_STOP_TYPE:
		((PrimMobJACmdStop *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_CMD_VEL_TYPE:
		((PrimMobJACmdVel *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_SET_TYPE:
		((PrimMobJASet *) buffer)->update(cms);
		break;
	case PRIM_MOB_JA_STAT_TYPE:
		((PrimMobJAStat *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}

/*
*	NML/CMS Update function for PrimMobJACfgCycleTime
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJACfgCycleTime::update(CMS *cms)
{

	cms->beginClass("PrimMobJACfgCycleTime","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);

	cms->endClass("PrimMobJACfgCycleTime","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACfgDebug
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJACfgDebug::update(CMS *cms)
{

	cms->beginClass("PrimMobJACfgDebug","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("debug",debug);

	cms->endClass("PrimMobJACfgDebug","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACfgMove
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJACfgMove::update(CMS *cms)
{

	cms->beginClass("PrimMobJACfgMove","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("vmax",vmax);
	cms->update_with_name("amax",amax);
	cms->update_with_name("wmax",wmax);
	cms->update_with_name("alphamax",alphamax);
	cms->update_with_name("vCutoffAngle",vCutoffAngle);
	cms->update_with_name("wCutoffAngle",wCutoffAngle);

	cms->endClass("PrimMobJACfgMove","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACfgNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJACfgNop::update(CMS *cms)
{

	cms->beginClass("PrimMobJACfgNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMobJACfgNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdAbort
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJACmdAbort::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdAbort","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMobJACmdAbort","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdDock
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJACmdDock::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdDock","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("freeSpaceUpperRight",freeSpaceUpperRight);
	cms->update_with_name("freeSpaceLowerLeft",freeSpaceLowerLeft);
	cms->update_with_name("stationUpperRight",stationUpperRight);
	cms->update_with_name("stationLowerLeft",stationLowerLeft);
	cms->update_with_name("dockPoint",dockPoint);

	cms->endClass("PrimMobJACmdDock","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdHalt
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJACmdHalt::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdHalt","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMobJACmdHalt","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdInit
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJACmdInit::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdInit","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMobJACmdInit","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdMoveArcSegment
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJACmdMoveArcSegment::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdMoveArcSegment","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_dla_length_with_name("arcList_length",arcList_length);
	cms->beginStructDynamicArray("arcList",arcList_length,100);
	for(int i_arcList = 0;i_arcList < arcList_length ;i_arcList++)
	{
		cms->beginStructArrayElem("arcList",i_arcList);
		nmlupdate(cms,&(arcList[i_arcList]));
		cms->endStructArrayElem("arcList",i_arcList);
	}
	cms->endStructDynamicArray("arcList",arcList_length,100);

	cms->endClass("PrimMobJACmdMoveArcSegment","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdMoveWaypoint
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJACmdMoveWaypoint::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdMoveWaypoint","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_dla_length_with_name("waypoint_length",waypoint_length);
	cms->beginStructDynamicArray("waypoint",waypoint_length,100);
	for(int i_waypoint = 0;i_waypoint < waypoint_length ;i_waypoint++)
	{
		cms->beginStructArrayElem("waypoint",i_waypoint);
		nmlupdate(cms,&(waypoint[i_waypoint]));
		cms->endStructArrayElem("waypoint",i_waypoint);
	}
	cms->endStructDynamicArray("waypoint",waypoint_length,100);

	cms->endClass("PrimMobJACmdMoveWaypoint","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdNop
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJACmdNop::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdNop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMobJACmdNop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdRotate
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJACmdRotate::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdRotate","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("theta",theta);
	cms->update_with_name("thetaTol",thetaTol);
	cms->update_with_name("direction",direction);

	cms->endClass("PrimMobJACmdRotate","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdShutdown
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJACmdShutdown::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdShutdown","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMobJACmdShutdown","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdStop
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJACmdStop::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdStop","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);

	cms->endClass("PrimMobJACmdStop","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJACmdVel
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJACmdVel::update(CMS *cms)
{

	cms->beginClass("PrimMobJACmdVel","RCS_CMD_MSG");
	RCS_CMD_MSG::update_cmd_msg_base(cms);
	cms->update_with_name("v",v);
	cms->update_with_name("w",w);

	cms->endClass("PrimMobJACmdVel","RCS_CMD_MSG");

}


/*
*	NML/CMS Update function for PrimMobJASet
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJASet::update(CMS *cms)
{

	cms->beginClass("PrimMobJASet","RCS_STAT_MSG");

	RCS_STAT_MSG::update_stat_msg_base(cms);
	cms->update_with_name("cycleTime",cycleTime);
	cms->update_with_name("debug",debug);
	cms->update_with_name("vmax",vmax);
	cms->update_with_name("amax",amax);
	cms->update_with_name("wmax",wmax);
	cms->update_with_name("alphamax",alphamax);
	cms->update_with_name("vCutoffAngle",vCutoffAngle);
	cms->update_with_name("wCutoffAngle",wCutoffAngle);
	cms->update_with_name("controlPoint",controlPoint);

	cms->endClass("PrimMobJASet","RCS_STAT_MSG");

}


/*
*	NML/CMS Update function for PrimMobJAStat
*	Automatically generated by NML CodeGen Java Applet.
*	on Wed May 21 11:35:56 PDT 2008
*/
void PrimMobJAStat::update(CMS *cms)
{

	cms->beginClass("PrimMobJAStat","RCS_STAT_MSG_V2");

	cms->beginBaseClass("RCS_STAT_MSG_V2");
	RCS_STAT_MSG_V2::update(cms);
	cms->endBaseClass("RCS_STAT_MSG_V2");

	cms->update_with_name("command_type_sent",command_type_sent);
	cms->update_with_name("serial_number_sent",serial_number_sent);
	cms->update_with_name("pathIndex",pathIndex);

	cms->endClass("PrimMobJAStat","RCS_STAT_MSG_V2");

}

