

import java.util.Date;
// Import all NML, CMS, and RCS classes and interfaces
import rcs.nml.*;

public class timetracker
{
    public static void reset_time_tracker(time_tracker tt)
    {
	Date now = new Date();

	tt.now = (double)(now.getTime())/1000.;
	tt.start = tt.now;
	tt.max = -1E9;
	tt.min = 1e9;
	tt.avg = -1E9;
	tt.elapsed = 0.0;
	tt.count =0;
	tt.last=0;
    }

    public static void cycle_time_tracker(time_tracker tt)
    {
	double new_time;
	Date now = new Date();

	if(tt.count <= 0)
	    {
		reset_time_tracker(tt);
		tt.count = 1;
	    }
	else
	    {
		new_time = (double)(now.getTime())/1000;
		tt.last  = new_time - tt.now;
		if(tt.last > tt.max)
		    {
			tt.max = tt.last;
		    }
		if(tt.last < tt.min)
		    {
			tt.min = tt.last;
		    }
		tt.now = new_time;
		tt.elapsed = tt.now - tt.start;
		tt.avg = tt.elapsed/tt.count;
		tt.count++;
	    }
    }
}

