/*****************************************************************************
  DISCLAIMER:
  This software was produced by the National Institute of Standards
  and Technology (NIST), an agency of the U.S. government, and by statute is
  not subject to copyright in the United States.  Recipients of this software
  assume all responsibility associated with its operation, modification,
  maintenance, and subsequent redistribution.

  See NIST Administration Manual 4.09.07 b and Appendix I. 
*****************************************************************************/
/*!
  \file   exampleScrollMap.hh
  \brief  Contains a header file for an example of using ScrollingMap
*/

/* See documentation in exampleScrollMap.cc and scrollingMap.hh */

#ifndef __exampleScrollMap_hh
#define __exampleScrollMap_hh

#define CELL_NAME exampleCell
#include "exampleCell.hh"
#include "scrollingMap.hh"

#endif
