#ifndef SIMWARE_KB_UTILS_HH
#define SIMWARE_KB_UTILS_HH

#include <string.h>
#include <vector>
#include <string>
using namespace std;
#include <ctype.h>
#include <posemath.h>

double dMod(double, double);
double ZeroTo2PI(double);
void Tokenize(const string& str,
	      vector<string>& tokens,
	      const string& delimiters = " ");
void Tokenize2(string& str,
	       vector<string>& tokens,
	       const string& delimiters = " ");
int nocase_cmp(const string & s1, 
	       const string& s2);
void dumpTokens(const vector<string>&);
int  findToken(const vector<string>&,string,unsigned int=0);



struct strCmp {
  bool operator()( const char* s1, const char* s2 ) const {
    return strcmp( s1, s2 ) < 0;
  }
};

#endif
