/*****************************************************************************
  DISCLAIMER:
  This software was produced by the National Institute of Standards
  and Technology (NIST), an agency of the U.S. government, and by statute is
  not subject to copyright in the United States.  Recipients of this software
  assume all responsibility associated with its operation, modification,
  maintenance, and subsequent redistribution.

  See NIST Administration Manual 4.09.07 b and Appendix I. 
*****************************************************************************/
/*!
  \file   exampleVoxel.hh
  \brief  Defines a voxel class to use in exampleScrollBox.cc
*/

#include "scrollingBoxVoxel.hh"

class exampleVoxel : public ScrollingBoxVoxel
{
public:
  exampleVoxel() : ScrollingBoxVoxel(){}
  ~exampleVoxel(){}
  void init(){item = ' ';}
  char item;
};
